
%if 0

lDebug - Free x86 DOS debugger

Copyright (C) 1995-2003 Paul Vojta
Copyright (C) 2008-2012 C. Masloch

Usage of the works is permitted provided that this
instrument is retained with the works, so that any entity
that uses the works is notified of this instrument.

DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.

%endif

[list -]
%if 0

lDebug build notes

Compile MKTABLES:	wcl -ox -3 -d__MSDOS__ mktables.c
or:	gcc -xc MKTABLES.C -o mktables -Wno-write-strings -DOMIT_VOLATILE_VOID
Execute MKTABLES:	mktables
	(This deletes debugtbl.old then creates debugtbl.inc.)
	(A temporary file named debugtbl.tmp is used.)
Assemble DEBUG.COM:	nasm debug.asm -I../macro/ -oDEBUG.COM
Assemble DEBUGX.COM:	nasm debug.asm -I../macro/ -d_PM -oDEBUGX.COM

OpenWatcom 1.9 was used for compiling MKTABLES but it should reasonably well
work with other C compilers. gcc 6.3.0 is now also able to compile MKTABLES.
Assembling lDebug requires NASM (2.12.01 tested).

Note that MKTABLES only needs to be used if either the source files changed or
the MKTABLES program itself has been altered. If the assembler and disassembler
table is not to change, NASM is sufficient to assemble lDebug.


lDebug build options

There are some more options that can be used on the NASM command line to create
alternative lDebug versions. Unless otherwise specified, each option is a flag
and so should be set to either 1 (to enable an option) or 0 (to disable it).
Omitting a numeric value as well as the equals sign enables the option too.

-d_FILENAME=	Set base string for file name. Up to six characters.
-d_PROGNAME=	Set program name string displayed in help screens.
-d_VERSION=	Set version string displayed after _PROGNAME. Include a blank.
-d_REVISIONID=	Set revision ID string. (Disabled if empty or undefined.)
-d_PM=		Set DPMI support.
-d_DEBUG=	Set support for debugging lDebug, for lDebug development. The
		interrupt handlers will be reset to these of the next debugger
		in lDebug code and the BU command breaks to the next debugger.
		(Currently does not work with DPMI support enabled.)
-d_EMS=		Set EMS allocation commands (XA, XD, XM, XR, XS, X?).
-d_INT=		Set command (DI) to display exception and interrupt handlers.
-d_MCB=		Set command (DM) to display DOS Memory Control Blocks.
-d_RN=		Set command (RN) to display numerical co-processor registers.
-d_DSTRINGS=	Set commands (DZ, D$, D#, DW#) to display strings in memory.
-d_SDUMP=	Set that the search command (S) displays memory after matches.
-d_COND=	Set that the register dump (R, T, P, G) displays jump notices.
-d_USESDA=	Set that switching processes uses the DOS Swappable Data Area.
-d_VDD=		Set NTVDM direct disk access support via loading DEBXXVDD.DLL.
-d_EXPRESSIONS=	Set expression evaluator that accepts calculations.
		(Currently is required enabled.)
-d_VARIABLES=	Set sixteen 32-bit variables (V0..VF) that can be set freely.
-d_OPTIONS=	Set 32-bit option variables (DCO, DCS, DIF, DAO, DAS).
-d_BOOTLDR=	Set boot loading support.
-d_NUM_G_BP=	Set number of temporary breakpoints. Must be numerical.
-d_MMXSUPP=	Set command (RM) to display MMX registers.
-d_CATCHINT06=	Set that Interrupt 06h (Invalid opcode) is hooked.
; -d_STACKSIZE=	Set size of lDebug's stack (in byte). Must be numerical.
-d_AUXBUFFSIZE=	Set size of the auxiliary buffer (in byte). Must be numerical.
	(The following only apply if DPMI support is enabled.)
-d_NOEXTENDER=	Set support of DPMI hosts without DOS extender.
-d_WIN9XSUPP=	Set Win9x detection to avoid hooking its DPMI entry.
-d_DOSEMU=	Set dosemu detection to avoid hooking its DPMI entry.
-d_EXCCSIP=	Set to display where exceptions inside lDebug occured.
-d_CATCHEXC06=	Set that exception 06h (Invalid opcode) is hooked.
-d_CATCHEXC0C=	Set that exception 0Ch (Stack fault) is hooked.
-d_DISPHOOK=	Set to display when the DPMI entry is hooked.

Refer to the list in debug.mac for the default values of these options. You
can also adjust the defaults there. Refer to the source code and commentary
for what each option does if these descriptions are not specific enough.


lDebug contributions

lDebug is based on DEBUG/X 1.13 to 1.18 as released by Japheth, whose work
on DEBUG/X has been released as Public Domain.

%endif

%include "debug.mac"

%ifndef _MAP
%elifstr _MAP
%elifempty _MAP
%else	; defined non-empty non-str
	[map all _MAP]
%endif

	cpu 8086
	org 100h
	sectalign off
	section lDEBUG align=1 start=100h
	section ASMTABLE1 align=1 follows=lDEBUG
	section ASMTABLE2 align=1 follows=ASMTABLE1
	section DATASTACK align=1 follows=ASMTABLE2 nobits
	section INIT align=1 follows=ASMTABLE2

	section lDEBUG
start:
%define SECTIONFIXUP -$$+100h

 %if _BOOTLDR
	test ax, 38		; signature as required by loader
 %endif
	jmp initcode

cmdlist:	dw aa,bb,cc,ddd,ee,ff,gg,hh,ii,error,error,ll,mm,nn,oo
		dw pp,qq,rr,sss,tt,uu,error,ww,xx

				; options, startoptions and internalflags
				; have to be consecutive
options:	dd DEFAULTOPTIONS ; run-time options
dispregs32	equ   1		; RX: 32-bit register display (R, T/P/G)
traceints	equ   2		; TM: trace into interrupts (T)
cpdepchars	equ   4		; allow dumping of CP-dependant characters (D, DX)
fakeindos	equ   8		; always assume InDOS flag non-zero (all)
nonpagingdevice	equ  10h	; disallow paged output with [more] prompt (all exc. P, T)
pagingdevice	equ  20h	; allow paged output with [more] prompt (all exc. P, T)
				; paged output is by default on if the output device is StdOut, else off
hexrn		equ  40h	; display raw hexadecimal content of FPU registers (RN)
;novdd		equ  80h	; don't use a registered NTVDM VDD (L, W)
nondospaging	equ 100h	; paging: don't use DOS for input when waiting for a key
nohlt		equ 200h	; HLT doesn't work, don't use it
biosidles	equ 400h	; don't idle with HLT or Int2F.1680, only call BIOS Int16.00
DEFAULTOPTIONS	equ 0

startoptions:	dd DEFAULTOPTIONS ; options as determined during startup; read-only for user

internalflags:	dd attachedterm|pagedcommand|notstdinput|inputfile|notstdoutput|outputfile|(!!_PM*dpminohlt)
				; flags only modified by DEBUG itself
oldpacket	equ	 1	; Int25/Int26 packet method available (L, W)
newpacket	equ	 2	; Int21.7305 packet method available (L, W)
ntpacket	equ	 4	; VDD registered and usable (L, W)
pagedcommand	equ	 8	; allows paging in puts
notstdinput	equ	10h	; DEBUG's StdIn isn't a device with StdIn bit (is file or other device)
inputfile	equ	20h	; DEBUG's StdIn is a file, notstdinput also set
notstdoutput	equ	40h	; DEBUG's StdOut isn't a device with StdOut bit (is file or other device)
outputfile	equ	80h	; DEBUG's StdOut is a file, notstdoutput also set
hooked2F	equ    100h	; Int2F hooked
nohook2F	equ    200h	; don't hook Int2F.1687 (required for Win9x, DosEmu?)
dpminohlt	equ    400h	; DPMI doesn't like hlt
protectedmode	equ    800h	; in (DPMI) protected mode
debuggeeA20	equ   1000h	; state of debuggee's A20
debuggerA20	equ   2000h	; state of debugger's A20 (will be on if possible)
nodosloaded	equ   4000h	; No DOS loaded currently (Boot loader mode)
has386		equ   8000h	; CPU is a 386
usecharcounter	equ  10000h	; don't reset charcounter between calls to puts
runningnt	equ  20000h	; running in NTVDM
canswitchmode	equ  40000h	; can switch modes (auxbuff large enough, DPMI mode switch set up)
modeswitched	equ  80000h	; switched mode (now in the mode that we weren't entered in)
promptwaiting	equ 100000h	; puts: any more output needs to display a prompt first
switchbuffer	equ 200000h	; mode switch needs a buffer (auxbuff)
tsrmode		equ 400000h	; in TSR mode; DPI and DPP not valid
attachedterm	equ 800000h	; the attached process terminated

asm_options:	dd DEFAULTASMOPTIONS
disasm_lowercase	equ 1
disasm_commablank	equ 2
disasm_nasm		equ 4
DEFAULTASMOPTIONS equ disasm_lowercase|disasm_commablank|disasm_nasm

asm_startoptions:
		dd DEFAULTASMOPTIONS

charcounter:	db 0		; used by raw output to handle tab
linecounter:	db 0		; used by paging in puts
savesp:		dw 0		; saved stack pointer
errret:		dw cmd3		; return here if error
throwret:	dw errhandler	; return here if error - priority, no display
throwsp:	dw 0		; stack pointer used by throwret users
run_sp:		dw 0		; stack pointer when running
spadjust:	dw 40h 		; adjust sp by this amount for save
pspdbe:		dw 0		; debuggee's PSP (unless DIF&attachedterm)
pspdbg:		dw 0		; debugger's PSP (RM segment)
run2324:	dd 0,0		; debuggee's interrupt vectors 23h and 24h (both modes)
%if _PM
		dd 0
dbg2324:	dw i23pm, i24pm
%endif
%if _VDD
hVdd:		dw -1		; NTVDM VDD handle
%endif
sav2324:	dd 0,0		; debugger's interrupt vectors 23h and 24h (real-mode only)
hakstat:	db 0		; whether we have hacked the vectors or not
psp22:		dd 0		; original terminate address from our PSP
parent:		dw 0		; original parent process from our PSP (must follow psp22)
%if _MCB
wMCB:		dw -1		; start of MCB chain (always segment)
%endif
pInDOS:		dd 0		; far16 address of InDOS flag (bimodal)
%if _PM
InDosSegm:	dw 0		; saved segment value of pInDOS
%endif
%if _USESDA
pSDA:		dd -1		; far16 address of SDA (bimodal)
%if _PM
SDASegm:	dw -1		; saved segment value of pSDA
%endif
%endif
machine:	db 0		; type of processor for assembler and disassembler (1..6)
has_87:		db 0		; if there is a math coprocessor present
mach_87:	db 0		; type of coprocessor present
%if _MMXSUPP
has_mmx:	db 0
%endif
bInDbg:		db 1		; 1=debugger is running
notatty:	db 10		; if standard input is from a file
				; this is also used for a linebreak processing hack
switchar:	db 0		; switch character
swch1:		db ' '		; switch character if it's a slash
promptlen:	dw 0		; length of prompt
bufnext:	dw line_in+2	; address of next available character
bufend:		dw line_in+2	; address + 1 of last valid character

a_addr:		dw 0,0,0	; address for next A command
d_addr:		dw 0,0,0	; address for next D command; must follow a_addr
u_addr:		dw 0,0,0	; address for next U command; must follow d_addr
e_addr:		dw 0,0,0	; address for current/next E command
%if _DSTRINGS
dz_addr:	dw 0,0,0	; address for next ASCIZ string
dcpm_addr:	dw 0,0,0	; address for next $-terminated string
dcount_addr:	dw 0,0,0	; address for next byte-counted string
dwcount_addr:	dw 0,0,0	; address for next word-counted string
%endif
%if _PM
x_addr:		dd 0		; (phys) address for next DX command
%endif
%if _DSTRINGS
dstringtype:	db 0		; FFh byte-counted, FEh word-counted, else terminator byte
dstringaddr:	dw dz_addr	; -> address of last string
%endif
%if _INT
lastint:	db 0
%endif
sscounter:	dw 0
%if _PM
		dw 0
%endif
rrtype:		db 0
eqflag:		db 0		; flag indicating presence of `=' operand
eqladdr:	dw 0,0,0	; address of `=' operand in G, P and T command
	align 2
run_int:	dw 0		; interrupt type that stopped the running
lastcmd:	dw dmycmd
bInit:		db 0		; 0=ensure a valid opcode is at debuggee's CS:IP
fileext:	db 0		; file extension (0 if no file name)
EXT_OTHER	equ 1
EXT_COM		equ 2
EXT_EXE		equ 4
EXT_HEX		equ 8
mmxbuff:	dd 0		; buffer with a (read-only) part of MMX register
				; for access from within expressions

inttab:
	db 0
	dw intr0	; table of interrupt initialization stuff
%if _CATCHINT01
	db 1
	dw intr1
%endif
%if _CATCHINT03
	db 3
	dw intr3
%endif
%if _CATCHINT06
	db 6
	dw intr6
%endif
	endarea inttab
	inttab_number equ inttab_size / 3

intsave:dd -1		; storage for interrupt vectors 00h, 01h, 03h, 06h
%if _CATCHINT01
	dd -1
%endif
%if _CATCHINT03
	dd -1
%endif
%if _CATCHINT06
	dd -1
%endif

		; Parameter block for EXEC call
execblk:dw 0		;(00) zero: copy the parent's environment
	dw 0,0		;(02) address of command tail to copy
	dw 5Ch,0	;(06) address of first FCB to copy
	dw 6Ch,0	;(10) address of second FCB to copy
	dw 0,0		;(14) initial SS:SP
	dw 0,0		;(18) initial CS:IP

%if _BOOTLDR
		; Data passed to us from loader (in case we booted)
init0data:
	times INIT0DATA_size db 0
%endif

		; Register save area (32 words).
		; must be DWORD aligned, used as stack
	align 4
regs:
reg_eax:	dd 0	;+00 eax
reg_ebx:	dd 0	;+04 ebx
reg_ecx:	dd 0	;+08 ecx
reg_edx:	dd 0	;+12 edx
reg_esp:	dd 0	;+16 esp
reg_ebp:	dd 0	;+20 ebp
reg_esi:	dd 0	;+24 esi
reg_edi:	dd 0	;+28 edi
reg_ds:		dd 0	;+32  ds (high word unused)
reg_es:		dd 0	;+36  es (high word unused)
reg_ss:		dd 0	;+40  ss (high word unused)
reg_cs:		dd 0	;+44  cs (high word unused)
reg_fs:		dd 0	;+48  fs (high word unused)
reg_gs:		dd 0	;+52  gs (high word unused)
reg_eip:	dd 0	;+56 eip
reg_efl:	dd 0	;+60 efl(ags)
%if _VARIABLES
vregs: times 16 dd 0	;+64 internal v0..vf
%endif


; Instruction set information needed for the 'p' command.
; ppbytes and ppinfo needs to be consecutive.
ppbytes	db 66h,67h,26h,2Eh,36h,3Eh,64h,65h,0F2h,0F3h	; prefixes
	db 0ACh,0ADh,0AAh,0ABh,0A4h,0A5h	; lods,stos,movs
	db 0A6h,0A7h,0AEh,0AFh			; cmps,scas
	db 6Ch,6Dh,6Eh,6Fh			; ins,outs
	db 0CCh,0CDh				; int instructions
	db 0E0h,0E1h,0E2h			; loop instructions
	db 0E8h					; call rel16/32
	db 09Ah					; call far seg16:16/32
;	(This last one is done explicitly by the code.)
;	db 0FFh					; FF/2 or FF/3: indirect call

PPLEN	equ	$-ppbytes	; size of the above table

;	Info for the above, respectively.
;	80h = prefix; 82h = operand size prefix; 81h = address size prefix.
;	If the high bit is not set, the next highest bit (40h) indicates that
;	the instruction size depends on whether there is an address size prefix,
;	and the remaining bits tell the number of additional bytes in the
;	instruction.

PP_ADRSIZ	equ 01h
PP_OPSIZ	equ 02h
PP_PREFIX	equ 80h
PP_VARSIZ	equ 40h

ppinfo	db 82h,81h,80h,80h,80h,80h,80h,80h,80h,80h
	db 0,0,0,0,0,0
	db 0,0,0,0
	db 0,0,0,0
	db 0,1
	db 1,1,1
	db 42h
	db 44h

%if PPLEN != $-ppinfo
 %error "ppinfo table has wrong size"
%endif


;	Equates for instruction operands.
;	First the sizes.

OP_ALL	equ 40h			; byte/word/dword operand (could be 30h but ...)
OP_1632	equ 50h			; word or dword operand
OP_8	equ 60h			; byte operand
OP_16	equ 70h			; word operand
OP_32	equ 80h			; dword operand
OP_64	equ 90h			; qword operand

OP_SIZE	equ OP_ALL		; the lowest of these

;	These operand types need to be combined with a size.

OP_IMM		equ 0		; immediate
OP_RM		equ 2		; reg/mem
OP_M		equ 4		; mem (but not reg)
OP_R_MOD 	equ 6		; register, determined from MOD R/M part
OP_MOFFS 	equ 8		; memory offset; e.g., [1234]
OP_R		equ 10		; reg part of reg/mem byte
OP_R_ADD 	equ 12		; register, determined from instruction byte
OP_AX		equ 14		; al or ax or eax

;	These don't need a size.

OP_M64		equ 2		; 0 qword memory (obsolete?)
OP_MFLOAT 	equ 4		; 1 float memory
OP_MDOUBLE 	equ 6		; 2 double-precision floating memory
OP_M80		equ 8		; 3 tbyte memory
OP_MXX		equ 10		; 4 memory (size unknown)
OP_FARMEM 	equ 12		; 5 memory far16/far32 pointer
OP_FARIMM	equ 14		; 6 far16/far32 immediate
OP_REL8		equ 16		; 7 byte address relative to IP
OP_REL1632 	equ 18		; 8 word or dword address relative to IP
OP_1CHK		equ 20		; 9 check for ST(1)
OP_STI		equ 22		;10 ST(I)
OP_CR		equ 24		;11 CRx
OP_DR		equ 26		;12 DRx
OP_TR		equ 28		;13 TRx
OP_SEGREG 	equ 30		;14 segment register
OP_IMMS8 	equ 32		;15 sign extended immediate byte
OP_IMM8		equ 34		;16 immediate byte (other args may be (d)word)
OP_MMX		equ 36		;17 MMx
OP_MMX_MOD	equ 38		;18 MMx, but in ModR/M part
OP_SHOSIZ 	equ 40		;19 set flag to always show the size

OP_1		equ 42		; 1 (simple "string" ops from here on)
OP_3		equ 44		; 3
OP_DX		equ 46		; DX
OP_CL		equ 48		; CL
OP_ST		equ 50		; ST (top of coprocessor stack)
OP_CS		equ 52		; CS
OP_DS		equ 54		; DS
OP_ES		equ 56		; ES
OP_FS		equ 58		; FS
OP_GS		equ 60		; GS
OP_SS		equ 62		; SS

	; Instructions that have an implicit operand subject to a segment prefix.
	; This means a prefixed segment is allowed by the strict assembler, and
	; the disassembler treats a segment prefix as part of the instruction and
	; displays it in front of the instruction's mnemonic.
	; (outs, movs, cmps, lods, xlat).
segprfxtab:
	db 06Eh,06Fh,0A4h,0A5h,0A6h,0A7h,0ACh,0ADh
a32prfxtab:
	db 0D7h				; xlat, last in segprfxtab, first in a32prfxtab
SEGP_LEN equ $-segprfxtab

		; Instructions that can be used with REPE/REPNE.
		; (ins, outs, movs, stos, lods; cmps, scas)
replist:db 06Ch,06Eh,0A4h,0AAh,0ACh	; REP (no difference)
REP_SAME_LEN equ $-replist		; number of indifferent replist entries
	db 0A6h,0AEh			; REPE/REPNE
REP_LEN equ $-replist
REP_DIFF_LEN equ REP_LEN-REP_SAME_LEN	; number of replist entries with difference

A32P_LEN equ $-a32prfxtab

; prfxtab P_LEN REP_LEN REPE_REPNE_LEN

		; All the instructions in replist also have an implicit operand
		; subject to ASIZE (similar to segprfxtab). Additionally, the
		; xlat instruction (0D7h) has such an implicit operand too.
		; maskmovq too.


	%include "asmtabs.asm"

	%include "msg.asm"


%if _PM
	align 4
dpmientry:	dd 0	; DPMI entry point returned by DPMI host
dpmiwatch:	dd 0
dpmi_rm2pm:	dd 0
dpmi_rmsav:	dd 0
dpmi_pm2rm:	dw 0,0,0
dpmi_pmsav:	dw 0,0,0
	align 2
dssel:		dw 0	; debugger's (16-bit RW) data selector
cssel:		dw 0	; debugger's (16-bit RE) code selector
scratchsel:	dw 0	; scratch selector used for various purposes, limit -1
dpmi32:		db 0	; 32-bit client if true
bCSAttr:	db 0	; current code attribute (D bit)
bAddr32:	db 0	; Address attribute. if 1, hiword(edx) is valid


		; Int2F handler. Starts with an IISP header.
debug2F:
	jmp short actual2F
oldi2F:	dd -1
	db "KB"
	db 0
	jmp short _retf
	times 7 db 0

actual2F:
	pushf
	cmp ax, 1687h
dpmidisable:		; set this byte to __TEST_IMM8 to disable new DPMI entry
	je dpmiquery
	popf
jumpoldi2F:
	jmp far [ cs:oldi2F ]

dpmiquery:
	push cs
	call jumpoldi2F
	test ax, ax
	jnz .nohost

	mov word [ cs:dpmientry+0 ], di
	mov word [ cs:dpmientry+2 ], es
	mov di, mydpmientry
	push cs
	pop es
.nohost:
	iret

mydpmientry:
	mov byte [ cs:dpmi32 ], 0
	test al, 1
	jz .16
	inc byte [ cs:dpmi32 ]
.16:
	call far [ cs:dpmientry ]
	jnc installdpmi
_retf:
	retf

%xdefine __CPU_PREV__ __CPU__
cpu 286
installdpmi:
	pusha
	mov bp, sp		; [bp+16]=ip, [bp+18]=cs
	pushf
	push ds
	mov bx, cs
	mov ax, 000Ah		; get a data descriptor for DEBUG's segment
	int 31h
	jc fataldpmierr
	mov ds, ax
	mov word [ cssel ], cs
	mov word [ dssel ], ds
	mov cx, 2		; alloc 2 descriptors
	xor ax, ax
	int 31h
	jc fataldpmierr
	mov word [ scratchsel ], ax	; the first is used as scratch descriptor
	mov bx, ax
	xor cx, cx
%if 1
_386	dec cx			; set a limit of FFFFFFFFh if 386
%else
	cmp byte [ dpmi32 ], 0
	je .16
	dec cx			; set a limit of FFFFFFFFh if 32-bit client
.16:
%endif
	or dx, byte -1
	mov ax, 0008h
	int 31h
	mov ax, 0003h
	int 31h			; get selector increment
%if 0
	jnc .03sup
	mov ax, 8
.03sup:
%endif
	add bx, ax		; the second selector is client's CS
	xor cx, cx		; this limit is FFFFh even for 32-bits
	mov ax, 0008h
	int 31h
	mov dx, word [ bp+18 ]	; get client's CS
	mov di, dx
	call setrmaddr		; set base
	mov ax, cs
	lar cx, ax
	shr cx, 8		; CS remains 16-bit
	mov ax, 0009h
	int 31h
	mov dx, bx
	mov word [ bp+18 ], bx

	cld

	mov si, convsegs
	mov cx, NUMSEGS
.loopseg:
	lodsw
	mov di, ax
	mov bx, word [di]
	mov ax, 0002h
	int 31h
	jc fataldpmierr
	mov word [di], ax
	loop .loopseg

_386	push edi
_386	xor edi, edi		; clear edih
	clropt [internalflags], canswitchmode|switchbuffer
	xor bp, bp
_386	inc bp
_386	inc bp
.save16:
	mov ax, 0305h		; get raw mode-switch save state addresses
	int 31h
	jc .cannotswitch
	cmp ax, _AUXBUFFSIZE	; fits into auxbuff ?
	ja .cannotswitch	; no -->
	test ax, ax
	jz .nobuffer
	setopt [internalflags], switchbuffer
	mov word [dpmi_rmsav+0], cx
	mov word [dpmi_rmsav+2], bx
	_386_o32	; mov dword [dpmi_pmsav], edi
	mov word [dpmi_pmsav], di
	mov word [ds:bp+dpmi_pmsav+2], si
.nobuffer:
_386	xor edi, edi		; clear edih
	mov ax, 0306h		; get raw mode-switch addresses
	int 31h
	jc .cannotswitch
	setopt [internalflags], canswitchmode
	mov word [dpmi_rm2pm+0], cx
	mov word [dpmi_rm2pm+2], bx
	_386_o32	; mov dword [dpmi_pm2rm], edi
	mov word [dpmi_pm2rm], di
	mov word [ds:bp+dpmi_pm2rm+2], si
.cannotswitch:
_386	pop edi

_386	push edx
_386	xor edx, edx		; clear edxh
	mov si, exctab		; hook several exceptions
	mov dx, exc00
.loopexc:
	lodsb
	mov bl, al
	mov cx, cs
	mov ax, 0203h
	int 31h
	add dx, byte exc01-exc00
	cmp si, endexctab
	jb .loopexc
_386	pop edx

	mov bl, 2Fh		; get int 2Fh real-mode vector
	mov ax, 0200h
	int 31h
	cmp cx, word [pspdbg]	; did we hook it and are the last in chain?
	jne .notours		; no -->
	mov dx, word [oldi2F+0]
	mov cx, word [oldi2F+2]	; then unhook
	mov ax, 0201h
	int 31h
	clropt [internalflags], hooked2F
.notours:
	pop ds
	popf
	popa
	retf

fataldpmierr:
	mov ax, 4CFFh
	int 21h

convsegs:
	dw pInDOS+2
%if _USESDA
	dw pSDA+2
%endif
	dw a_addr+4
	dw d_addr+4
NUMSEGS equ ($-convsegs)/2

exctab:
	db 00h
	db 01h
	db 03h
%if _CATCHEXC06
	db 06h
%endif
%if _CATCHEXC0C
	db 0Ch
%endif
	db 0Dh
	db 0Eh
endexctab:


	struc exceptionframe16
		resw 8			; pusha
fr16_ds:	resw 1			; push ds
		resw 2			; 16-bit return address to DPMI host
		resw 1			; error code
fr16_ip:	resw 1
fr16_cs:	resw 1
fr16_fl:	resw 1
fr16_sp:	resw 1
fr16_ss:	resw 1
	endstruc

	struc exceptionframe32
		resd 8			; pushad
		resw 1			; stack alignment
fr32_ds:	resw 1			; push ds
		resd 2			; 32-bit return address to DPMI host
		resd 1			; error code
fr32_eip:	resd 1
fr32_cs:	resd 1
fr32_efl:	resd 1
fr32_esp:	resd 1
fr32_ss:	resd 1
	endstruc

	%macro exc_entry 2-3.nolist
exc %+ %1 %+ :
	push ds
	push %2
%ifempty %3
	jmp short exc
%elifnidn %3,last
 %fatal Invalid third parameter
%endif
	%endmacro

		; Exception handlers.
		; These are the entry into the debugger in protected mode.
		; The address difference between exc00 and exc01 is
		; assumed to be the same for all the entries. (Above, in
		; installdpmi, where the exception handlers are installed.)

	exc_entry 00, int0msg
	exc_entry 01, int1msg
	exc_entry 03, int3msg
%if _CATCHEXC06
	exc_entry 06, exc6msg
%endif
%if _CATCHEXC0C
	exc_entry 0C, excCmsg
%endif
	exc_entry 0D, excDmsg
	exc_entry 0E, excEmsg, last
exc:
	mov ds, word [cs:dssel]
	pop word [run_int]
	cmp byte [dpmi32], 0
	jz exc16

[cpu 386]
exc32:
	push ax				; stack alignment
	pushad
	mov ebp, esp
	mov eax, dword [ ebp + fr32_eip ]
	mov bx, word [ ebp + fr32_cs ]
	mov ecx, dword [ ebp + fr32_efl ]
	mov edx, dword [ ebp + fr32_esp ]
	mov si, word [ ebp + fr32_ss ]
	mov word [ ebp + fr32_cs ], cs
	mov word [ ebp + fr32_ss ], ds
	cmp byte [ bInDbg ], 0		; did the exception occur inside DEBUG?
	je @F				; no -->

		; inside debugger
	push ds
	pop es
%if _EXCCSIP
	mov di, exccsip
	mov ax, bx
	call hexword
	inc di
	mov ax, word [ ebp + fr32_eip ]
	call hexword
%endif
	mov dword [ ebp + fr32_eip ], debuggerexception
	movzx eax, word [ savesp ]
	mov dword [ ebp + fr32_esp ], eax
	clropt [ ebp + fr32_efl ], 100h	; reset TF
	jmp short @FF

@@:		; inside debuggee
	setopt [internalflags], protectedmode
	mov dword [ ebp + fr32_eip ], intrtn2
	clropt [ ebp + fr32_efl ], 300h	; reset IF + TF
	mov dword [ ebp + fr32_esp ], reg_ss
	mov dword [ reg_eip ], eax
	mov word [ reg_cs ], bx
	; mov dword [ reg_efl ], ecx	; (eflh is saved in intrtn2)
	mov word [ reg_efl ], cx
	mov dword [ reg_esp ], edx
	mov word [ reg_ss ], si
	push word [ ebp + fr32_ds ]
	pop word [ reg_ds ]

@@:
	popad
	pop ax				; stack alignment
	pop ds
	o32 retf

__CPU__
exc16:
	pusha
	mov bp, sp
	mov ax, word [ bp + fr16_ip ]
	mov bx, word [ bp + fr16_cs ]
	mov cx, word [ bp + fr16_fl ]
	mov dx, word [ bp + fr16_sp ]
	mov si, word [ bp + fr16_ss ]
	mov word [ bp + fr16_cs ], cs
	mov word [ bp + fr16_ss ], ds
	cmp byte [ bInDbg ], 0		; did the exception occur inside DEBUG?
	je isdebuggee16
	push ds
	pop es
%if _EXCCSIP
	mov di, exccsip			; render CS:IP if internal GPF
	mov ax, bx
	call hexword
	inc di
	mov ax, word [ bp + fr16_ip ]
	call hexword
%endif
	mov word [ bp + fr16_ip ], debuggerexception
	mov ax, word [ savesp ]
	mov word [ bp + fr16_sp ], ax
	clropt [ bp + fr16_fl ], 100h	; reset TF
	jmp short isdebugger16
isdebuggee16:
	setopt [internalflags], protectedmode
	mov word [ bp + fr16_ip ], intrtn2
	clropt [ bp + fr16_fl ], 300h	; reset IF + TF
	mov word [ bp + fr16_sp ], reg_ss
	mov word [ reg_eip ], ax
	mov word [ reg_cs ], bx
	mov word [ reg_efl ], cx
	mov word [ reg_esp ], dx
	mov word [ reg_ss ], si
	push word [ bp + fr16_ds ]
	pop word [ reg_ds ]
isdebugger16:
	popa
	pop ds
	retf

%xdefine __CPU__ __CPU_PREV__
%undef __CPU_PREV__
__CPU__


		; Test if bx is a 32-bit selector (as opposed to a 16-bit selector or a segment)
		;
		; INP:	bx = selector (PM) or segment (RM)
		; OUT:	NZ = 32-bit
		;	ZR = 16-bit
		;	NC
testattrhigh:
_386	call ispm
_386	jz .pm				; 386 and PM, check selector -->
		; not PM or no 386
	cmp al, al			; ZR, NC
	retn
.pm:
[cpu 386]
	push eax
	lar eax, ebx			; access rights
	test eax, 400000h		; test bit (NC)
	pop eax
	retn
__CPU__


i23pm:
	cmp byte [ cs:dpmi32 ], 0	; always NC
	je .retf16_2
	o32
	retf 4				; retfd 4
.retf16_2:
	retf 2

i24pm:
	mov al, 03h			; fail
	cmp byte [ cs:dpmi32 ], 0
	je .iret16
	o32				; iretd
.iret16:
	iret

cpu 8086
%endif	; _PM

%if _DEBUG4
%include "deb.asm"
%endif


		; debug22 - Interrupt 22h handler
		;
		; This is for DEBUG itself: it's a catch-all for the various Int23
		; and Int24 calls that may occur unpredictably at any time. What we
		; do is pretend to be a command interpreter (which we are, in a sense,
		; just with different sort of commands) by setting our parent PSP
		; value equal to our own PSP so that DOS does not free our memory when
		; we quit. Therefore control ends up here when DOS detects Control-C
		; or an Abort in the critical error prompt is selected.
debug22:
	cld			; reestablish things
	mov ax, cs
	mov ds, ax
	mov ss, ax

		; Begin main command loop.
cmd3:
	mov sp, word [ savesp ]	; restore stack (this must be first)
	mov word [ errret ], cmd3
	mov word [ throwret ], errhandler
	push ds
	pop es
	call ensuredebuggeeloaded	; if no task is active, create a dummy one
	mov di, line_out	; build prompt
%if _DEBUG
	mov al, '~'		; indicate instance is to be debugged
	stosb
%endif
	mov al, '-'		; main prompt
%if _PM
	call ispm
	jnz .realmode
	mov al, '#'		; PM main prompt
.realmode:
%endif
	stosb

	mov byte [hhflag], 0
	setopt [internalflags], pagedcommand	; 2009-02-21: default to page all commands
	clropt [internalflags], usecharcounter	; reset this automatically

	call getline00		; prompted input, also resets linecounter

	cmp al, 13
	jne .notblank
	mov dx, word [lastcmd]
	dec si
	jmp short cmd4
.notblank:
	mov word [lastcmd], dmycmd
	cmp al, ';'
	je cmd3			; if comment -->
	cmp al, '?'
	je help			; if request for help -->
	call uppercase
	sub al, 'A'
	cmp al, 'X'-'A'
	ja short errorj1	; if not recognized
	cbw
	xchg bx, ax
	call skipcomma
	shl bx, 1
	mov dx, word [ cmdlist+bx ]
cmd4:
	mov di, line_out
	call dx
cmd3_j1:
	jmp short cmd3		; back to the top


dmycmd:
	retn

help:
	call skipcomma
	call uppercase
%if _EXTHELP
 %if _COND
	mov dx, msg.condhelp
	cmp al, 'C'
	je .spec
 %endif
 %if _OPTIONS
	mov dx, msg.ophelp
	cmp al, 'O'
	je .spec		; option help -->
 %endif
 %if _EXPRESSIONS
	mov dx, msg.expressionhelp
	cmp al, 'E'
	je .spec
 %endif
%endif
%if _EMS
	mov dx, msg.xhelp
	cmp al, 'X'
	je .spec
%endif
	mov dx, msg.build
	cmp al, 'B'
	je .spec		; build info -->
%if _EXTHELP
	mov dx, msg.license
	cmp al, 'L'
	je .spec		; licence -->
	mov dx, msg.flaghelp
	cmp al, 'F'
	je .spec		; flag help -->
	mov dx, msg.reghelp
	cmp al, 'R'
	je .spec		; register help -->
 %if _VARIABLES || _OPTIONS || _PSPVARIABLES
	mov dx, msg.varhelp
	cmp al, 'V'
	je .spec		; variable help -->
 %endif
%endif
	mov dx, msg.help	; default help
	db __TEST_IMM8		; (skip lodsb)
.spec:
	lodsb
	call chkeol
prnquit:
	call putsz		; print string
	jmp short cmd3_j1	; done

errorj1:jmp error


%include "aa.asm"
%include "dd.asm"
%include "rr.asm"
%if _RN
%include "fptostr.asm"
%endif
%include "run.asm"
%include "uu.asm"


		; C command - compare bytes.
cc:
	call parsecm		; parse arguments

		; To make the 16-bit 64 KiB compare hack below work, the
		; full ecx mustn't be increased here for 16-bit segments.
		; The passed ecx isn't higher than FFFFh for 16-bit segments,
		; and a value of 0001_0000h needs to be passed as zero to
		; the hack anyway.
%if _PM
	cmp byte [ss:bAddr32], 0
	je .16
cpu 386
	inc ecx
	jnz cc1
	jmp error
cpu 8086
.16:
%endif
	inc cx
cc1:
	push ds
	push es
	push ss
	pop ds			; ds := cs
	call dohack		; do the interrupt pointer hack
	pop es
	pop ds
%if _PM
	cmp byte [ss:bAddr32], 0
	jz .cmp16
	a32 repe cmpsb
	mov dl, byte [esi-1]
	mov dh, byte [es:edi-1]
	jmp short .cmpdone
.cmp16:
%endif
		; The following 3 instructions make a hack to support 64 KiB
		; compare. The only time we get here with cx = 0 is the first
		; iteration for a 64 KiB compare. In that case, dec cx results
		; in FFFFh making repe cmpsb work. The single cmpsb will either
		; jump the repe cmpsb (if it found a mismatch) or not jump it.
		; The repe cmpsb might be executed with cx = 0, but will then
		; not change anything including the flags so it works.
	dec cx
	cmpsb
	jne .skip
	repe cmpsb		; start comparing
.skip:
	mov dl, byte [si-1]	; save the possibly errant characters
	mov dh, byte [es:di-1]
.cmpdone:
	lahf
	push ds
	push es
	push ss
	pop ds
	call unhack		; undo the interrupt pointer hack
	pop es
	pop ds
	sahf
	je cc2			; if we're done
	push es
	push ss
	pop es
	_386_PM_o32	; mov ebx, edi
	mov bx, di
	mov	di, line_out
	mov	ax, ds
	call hexword
	mov	al, ':'
	stosb
	_386_PM_o32	; mov eax, esi
	mov ax, si
	_386_PM_o32	; dec eax
	dec ax
%if _PM
	cmp byte [ss:bAddr32], 0
	jz .16si
	call hexword_high
.16si:
%endif
	call hexword
	mov ax, 32<<8|32
	stosw
	mov al, dl
	call hexbyte
	mov ax, 32<<8|32
	stosw
	mov al, dh
	call hexbyte
	mov ax, 32<<8|32
	stosw
	pop	ax
	push	ax
	call hexword
	mov al, ':'
	stosb
	_386_PM_o32	; mov eax, ebx
	mov ax, bx
	_386_PM_o32	; dec eax
	dec ax
%if _PM
	cmp byte [ss:bAddr32], 0
	jz .16bx
	call hexword_high
.16bx:
%endif
	call hexword
	push ds
	push ss
	pop ds
	push bx
	push cx
	call putsline_crlf
	pop cx
	pop	di
	pop	ds
	pop	es
%if _PM
	cmp byte [ss:bAddr32],0
	jz cc1_6
cpu 386
	jecxz cc2
cpu 8086
 cc1_j1:
	jmp cc1
cc1_6:
%else
 cc1_j1 equ cc1
%endif
%if 0
	_386_PM_o32	; inc ecx
	inc cx
	_386_PM_a32	; loopd cc1
	loop cc1		; if not done yet
%else
	_386_PM_a32	; jecxz cc2
	jcxz cc2
	jmp cc1			; if not done yet
%endif
cc2:
	push ss			; restore segment registers
	pop ds
	push ss
	pop es
	retn


bb:

	call uppercase
	cmp al, 'U'		; BU command ?
	je bu_breakpoint


	jmp error

bu_breakpoint:
	lodsb
	call chkeol
%if _DEBUG
	mov dx, msg.bu
	call putsz
	int3
	retn
%else
	mov dx, msg.notbu
	jmp putsz
%endif


uppercase:
	cmp al, 'a'
	jb .ret
	cmp al, 'z'
	ja .ret
	and al, TOUPPER
.ret:
	retn


errorj4:
	jmp error


		; E command - edit memory.
ee:
	call prephack
	mov bx, word [reg_ds]
	call getaddr		; get address into bx:(e)dx
	call skipcomm0
	cmp al, ';'
	je ee1
	cmp al, 13
	je ee1			; if prompt mode

	push dx			; save destination offset
	call getstr		; get data bytes
	mov cx, di
	mov dx, line_out
	sub cx, dx		; length of byte string
	pop di
	mov ax, cx
	dec ax
	add ax, di
	jc short errorj4	; if it wraps around
	call dohack
	mov si, dx
	mov es, bx
%if _PM
	cmp byte [bAddr32], 0
	jz ee_2
cpu 386
	mov dx, di		; dx was destroyed
	mov edi, edx
	movzx esi, si
	movzx ecx, cx
	a32
cpu 8086
ee_2:
%endif
	rep movsb

		; Restore ds + es and undo the interrupt vector hack.
		; This code is also used by the `m' command.
ee0a:
	push ss			; restore ds
	pop ds
	push ss			; restore es
	pop es
	mov di, run2324		; debuggee's int 23/24 values
	call prehak1		; copy things back
	jmp unhack



		; Prompt mode.
ee1:
		; Begin loop over lines.
ee2:				; <--- next line
	mov di, line_out
	mov ax, bx		; print out segment and offset
	call hexword
	mov al, ':'
	stosb
	_386_PM_o32		; mov eax, edx
	mov ax, dx
%if _PM
	call testattrhigh	; 32-bit segment ?
	jz .16			; no -->
	call hexword_high
.16:
%endif
	call hexword

		; Begin loop over bytes.
ee3:				; <--- next byte
	mov ax, 32<<8|32	; print old value of byte
	stosw
	call dohack		; do the INT pointer hack
	call readmem		; read mem at BX:(E)DX
	call unhack		; undo the INT pointer hack
	call hexbyte
	mov al, '.'
	stosb
	mov byte [ linecounter ], 0	; reset counter
	clropt [internalflags], promptwaiting
	push bx
	push dx
	call putsline
	pop dx
	pop bx
	mov si, line_out+16	; address of buffer for characters
	xor cx, cx		; number of characters so far

ee4:
	cmp byte [notatty], 0
	je ee9			; if it's a TTY
	push si
	mov di, line_in+2
	mov si, word [bufnext]
ee5:
	cmp si, word [bufend]
	jb ee6			; if there's a character already
	call fillbuf
	mov al, 13
	jc ee8			; if eof
ee6:
	cmp byte [notatty], 13
	jne ee7			; if no need to compress CR/LF
	cmp byte [si], 10
	jne ee7			; if not a line feed
	inc si			; skip it
	inc byte [notatty]	; avoid repeating this
	jmp short ee5		; next character

ee7:
	lodsb			; get the character
	mov byte [notatty], al
ee8:
	mov word [bufnext], si
	pop si
	jmp short ee10

ee9:
	call getc		; character input without echo
ee10:
	cmp al, 32
	je ee13
	cmp al, '.'
	je ee13
	cmp al, 13
	je ee13			; all: if done with this byte -->
	cmp al, 8
	je ee11			; if backspace
	cmp al, '-'
	je ee112		; if '-'
	cmp cx, byte 2		; otherwise, it should be a hex character
	jae ee4			; if we have a full byte already
	mov byte [si], al
	call getnyb
	jc ee4			; if it's not a hex character
	inc cx
	lodsb			; get the character back
	jmp short ee12
ee112:
	call putc
	dec dx			; decrement offset part
	mov di, line_out
	jmp short ee15
ee11:
	jcxz ee4		; if nothing to backspace over
	dec cx
	dec si
	call fullbsout
	jmp short ee4
ee12:
	call putc
	jmp short ee4		; back for more

		; We have a byte (if CX != 0).
ee13:
	jcxz ee14		; if no change for this byte
	mov byte [si], al	; terminate the string
	sub si, cx		; point to beginning
	push cx
	push dx
	lodsb
	call getbyte		; convert byte to binary (DL)
	mov al,dl
	pop dx
	pop	cx
	call dohack		; do the INT pointer hack
	call writemem		; write AL at BX:(E)DX
	mov di, run2324		; debuggee's int 23/24
	call prehak1		; copy things back
	call unhack		; undo the INT pointer hack

		; End the loop over bytes.
ee14:
	inc dx			; increment offset
	mov di,line_out
	cmp al, '.'
	je ee16
	cmp al, 13
	je ee16			; both: if done -->
	test dl, 7
	jz ee15			; if new line
	not cx
	add cx, byte 4		; compute 3 - cx
	mov al, 32
	rep stosb		; store that many spaces
	jmp ee3			; back for more

ee15:
	mov ax, 10<<8| 13	; terminate this line
	stosw
	jmp ee2			; back for a new line

ee16:
	jmp putsline_crlf	; call putsline and return


		; F command - fill memory
ff:
	xor cx, cx		; get address range (no default length)
	mov bx, word [reg_ds]
	call getrange		; get address range into bx:(e)dx
	_386_PM_o32	; sub ecx, edx
	sub cx, dx
	_386_PM_o32	; inc ecx
	inc cx			; (e)cx = number of bytes
	_386_PM_o32	; push ecx
	push cx			; save it
	_386_PM_o32	; push edx
	push dx			; save start address
	call skipcomm0
	call getstr		; get string of bytes
	mov cx, di
	sub cx, line_out
_386_PM	movzx ecx, cx
	_386_PM_o32	; pop edi
	pop di
	_386_PM_o32	; pop eax
	pop ax
%if _PM
	cmp byte [bAddr32], 0
	jz ff16
ff32:
cpu 386
	mov es, bx
	cmp ecx, byte 1
	je .onebytesource
	xor edx, edx		; edx:eax = size
	div ecx
	test eax, eax
	jz .partial
.loop:
	mov esi, line_out
	push ecx
	a32 rep movsb
	pop ecx
	dec eax
	jnz .loop
.partial:
	mov ecx, edx		; get remainder (number of bytes in partial copy)
	jecxz ffret		; if no partial copy -->
	mov si, line_out
	a32 rep movsb
	jmp short ffret		; done -->
.onebytesource:
	mov ecx, eax		; size
	mov al, byte [line_out]
	a32 rep stosb
	jmp short ffret
cpu 8086
ff16:
%endif
	mov es, bx
	cmp cx, byte 1
	je .onebytesource	; a common optimization
	xor dx, dx		; dx:ax = size
	cmp ax, byte 1
	adc dx, byte 0		; convert 0000:0000 to 0001:0000 (0 = 64 KiB)
	div cx			; compute number of whole repetitions
	test ax, ax
	jz .partial		; if less than one whole rep
.loop:
	mov si, line_out
	push cx
	rep movsb
	pop cx
	dec ax
	jnz .loop		; if more to go
.partial:
	mov cx, dx		; get remainder (number of bytes in partial copy)
	jcxz ffret		; if no partial copy -->
	mov si, line_out
	rep movsb
	jmp short ffret		; done -->
.onebytesource:
	mov cx, ax		; size
	mov al, byte [line_out]
	stosb			; cx=0 -> 64 kB
	dec cx
	rep stosb
ffret:
	push ss			; restore es
	pop es
	retn


%if _EXPRESSIONS

		; H command - hex computation
hh:
	call skipcomm0
	push si
	push ax
	or byte [hhflag], 1	; set flag so no operator means add
	call .compute
	pop ax
	pop si
	test byte [hhflag], 4	; any two-fold operation ?
	jz .done		; no -->
	push ax
	mov ax, 32<<8|32
	stosw
	pop ax
	or byte [hhflag], 2	; set flag so no operator means sub
	call .compute
.done:
	jmp putsline_crlf

.compute:
	call getdword
	call chkeol		; expect end of line here
	call .store
	test bx, bx		; result negative ?
	jns .comp_ret		; no -->
	mov ax, " ("
	stosw
	mov al, "-"
	stosb
	neg bx
	neg dx
	sbb bx, byte 0		; neg bx:dx
	call .store		; display "FFFFFFFF (-0001)"
	mov al, ")"
	stosb
.comp_ret:
	retn

.store:
	test bx, bx
	jz .store_nothigh	; no need to display 32-bit value
	mov ax, bx
	call hexword
.store_nothigh:
	mov ax, dx
	jmp hexword

%else
		; H command - hex addition and subtraction.
hh:
	call getdword
	push bx
	push dx
	call skipcomm0
	call getdword
	call chkeol		; expect end of line here
	pop cx
	pop ax			; first value in AX:CX, second in BX:DX
	mov si, ax
	mov bp, cx		; first value in SI:BP now
	mov ax, cx
	add ax, dx
	push ax
	mov ax, si
	adc ax, bx
	jz .nothigh1		; no need to display 32-bit value
	call hexword
.nothigh1:
	pop ax
	call hexword
	mov ax, 2020h
	stosw
	mov ax, bp
	sub ax, dx
	push ax
	mov ax, si
	sbb ax, bx
	jz .nothigh2		; no need to display 32-bit value
	or si, bx
	jz .nothigh2		; both were zero, non-zero result only by carry -->
	call hexword
.nothigh2:
	pop ax
	call hexword
	call putsline_crlf
	retn
%endif


		; O command - output to I/O port.
oo:
	mov ah, 'O'
	mov bx, .tab
	jmp short ii.common

.tab:
	dw .byte, .word, .dword


.byte:
	call getbyte		; read value from command line
	call chkeol		; expect end of line here
	xchg ax, dx		; al = value
	pop dx			; recover port number
	out dx, al		; send
	retn

.word:
	call getword
	call chkeol
	xchg ax, dx		; ax = value
	pop dx
	out dx, ax
	retn

.dword:
cpu 386
	call getdword
	call chkeol		; expect end of line here
	push bx
	push dx
	pop eax			; eax = value
	pop dx
	out dx, eax
	retn
cpu 8086


		; I command - input from I/O port.
ii:
	mov ah, 'I'
	mov bx, .tab

		; bx = jump table for byte, word, dword handler
		; ah = letter of the command
		; si, al etc.
.common:
	push ax
	call uppercase
	cmp al, 'W'
	jne .notw
.incbx2:
	inc bx
	inc bx			; use word handler
	call skipwhite		; skip the 'W' til next character
	jmp short .sizeset

.notw:
	cmp al, 'D'
	jne .sizeset
%if 1
	xor ah, byte [si-2]
	jz .d			; "Id" or "Od" --> (uppercase command)
	xor ah, 32
	jnz .sizeset		; no space is allowed between the command and 'D' -->
			; "id" or "od" here (lowercase command)
.d:
%endif
_386	inc bx
_386	inc bx			; use dword handler
	_386_jmps .incbx2	; bx += 2 and skip the 'D'
			; no 386 here. try with D as part of port number
.sizeset:
	call getword		; get port
	pop cx			; restore letter if necessary
	cmp ch, 'I'		; check whether I or O
	jne .o			; O -->
	call chkeol		; expect end of line here for I commands
	db __TEST_IMM8		; (skip push)
.o:
	push dx			; save port number for O commands
	jmp near [bx]


.tab:
	dw .byte, .word, .dword

.byte:
	in al, dx
	call hexbyte
	jmp short .done

.word:
	in ax, dx
.doneword:
	call hexword
.done:
	jmp putsline_crlf

.dword:
cpu 386
	in eax, dx
	call hexword_high
cpu 8086
	jmp short .doneword


errorj5:jmp	error


%if _PM
		; OUT:	NC
		;	ZR if in protected mode
		;	NZ otherwise
		; STT:	-
		;	([internalflags] & nodosloaded, [internalflags] & protectedmode set up)
ispm:
	push ax
%if protectedmode & ~0FF00h
 %error Internal flags re-ordered, adjust code here
%endif
	mov al, byte [ss:internalflags+1]	; get flag byte
	and al, protectedmode>>8		; separate PM flag
	xor al, protectedmode>>8		; ZR if in PM (NC)
	pop ax
	retn
%endif


setpspdbg:
	mov bx, cs
setpsp:
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jnz .ret		; no PSPs -->
%endif
	mov ah, 50h
%if _PM && (_NOEXTENDER || _USESDA)
	call ispm
 %if _NOEXTENDER
	jnz .rm
cpu 286
	push cx
	push dx
	push bx
	push ax
	mov ax, 0006h
	int 31h
	pop ax
	shl cx, 12
	shr dx, 4
	or dx, cx
	mov bx, dx
	call _doscall.pm	; insure non-extended
	pop bx
	pop dx
	pop cx
	retn
cpu 8086
 %else
	jz _int21		; extended
 %endif
%endif
.rm:
%if _USESDA
	cmp word [pSDA+0], byte -1
	je _int21
	push ds
	push si
	lds si, [pSDA]
	mov word [si+10h], bx
	pop si
	pop ds
	retn
%else
	jmp short _int21
%endif
%if _BOOTLDR
.ret:
getpsp.ret:
	retn
%endif

getpsp:
%if _BOOTLDR
	xor bx, bx
	testopt [internalflags], nodosloaded
	jnz .ret		; no PSPs -->
%endif
	mov ah, 51h
%if _PM && (_NOEXTENDER || _USESDA)
	call ispm
 %if _NOEXTENDER
	jnz .rm
	call _doscall.pm	; insure non-extended
	mov ax, 2
	int 31h
	mov bx, ax
	retn
 %else
	jz _int21		; extended
 %endif
%endif
.rm:
%if _USESDA
	cmp word [pSDA+0], byte -1
	je _int21
	push ds
	lds bx, [pSDA]
	mov bx, word [bx+10h]
	pop ds
	retn
%else
	jmp short _int21
%endif

%if _PM && _NOEXTENDER
		; When we support non-extended DPMI, some calls to Int21
		; are (extended) Int21 calls and some are (not extended)
		; calls down to the real mode Int21. doscall is a macro
		; that will always call the non-extended Int21.
%macro doscall 0
	call _doscall
%endmacro

		; Execute a non-extended DOS call
_doscall:
	call ispm
	jnz .rm
cpu 286
		; Execute a non-extended DOS call from PM
.pm:
	push word [ss:pspdbg]
	push 21h
	call intcall
	retn
cpu 8086
.rm equ _int21
%else
		; When we don't support non-extended DPMI all Int21 calls
		; are either in Real Mode or extended (all are real Int21
		; instructions).
%macro doscall 0
	int 21h
%endmacro
%endif

		; Execute real Int21 instruction. If this is in PM it might get extended.
_int21:
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jnz .reterr		; no Int21 --> (throw?)
%endif
	int 21h
	retn
%if _BOOTLDR
.reterr:
	mov ax, 1
	stc
	retn
%endif


%if _PM
intcall:
_386	movzx edi,di			; (previously checked b[dpmi32] here)
	push bp
	sub sp, 32h
	mov bp, sp
	push es
	push ss
	pop es
	mov word [bp+00h], di
	mov word [bp+04h], si
	mov word [bp+10h], bx
	mov word [bp+14h], dx
	mov word [bp+18h], cx
	mov word [bp+1Ch], ax
	mov ax, word [bp+32h]
	mov word [bp+08h], ax		; bp
	xor ax, ax
	mov word [bp+20h], ax		; flags
	mov word [bp+2Eh], ax		; sp
	mov word [bp+30h], ax		; ss
	mov ax, word [bp+38h]		; usually [pspdbg]
	mov word [bp+22h], ax		; es
	mov word [bp+24h], ax		; ds
	mov di, bp
	mov bx, word [bp+36h]		; int#
	xor cx, cx
	mov ax, 0300h
	int 31h
	mov ah, byte [bp+20h]
	lahf
	mov di, word [bp+00h]
	mov si, word [bp+04h]
	mov bx, word [bp+10h]
	mov dx, word [bp+14h]
	mov cx, word [bp+18h]
	mov ax, word [bp+1Ch]
	pop es
	lea bp, [bp+32h]
	mov sp, bp
	pop bp
	retn 4

		; Called in PM only, ds unknown.
		;
		; INP:	-
		; OUT:	CY if no DOS extender available ("MS-DOS" on Int2F.168A)
		;	NC if DOS extender available
		; CHG:	-
isextenderavailable:
cpu 286
	push ds
	push es
	pusha
	push ss
	pop ds
	mov si, msg.msdos
_386	movzx esi, si
	mov ax, 168Ah
	int 2Fh
	cmp al, 1			; CY if al is zero
	cmc				; NC if al is zero, CY else
	popa
	pop es
	pop ds
	retn
cpu 8086

nodosextinst:
	push ss
	pop ds
	mov dx, nodosext
	jmp putsz
%endif


		; L command - read a program, or disk sectors, from disk.
ll:
	call parselw		; parse L and W argument format
	jz ll1			; if request to read program
%if _PM && _NOEXTENDER
	call ispm
	jnz .rm
	call isextenderavailable
	jc nodosextinst
.rm:
%endif
	testopt [ss:internalflags], newpacket| ntpacket
	jz .oldint
	mov dl, al		; zero-based drive
	mov si, 6000h		; read, assume "file data"
%if _VDD
	testopt [internalflags], ntpacket
	jnz .vdd
%endif
	inc dl			; one-based drive
	mov ax, 7305h		; ds:(e)bx-> packet
	stc
	int 21h			; use int 21h here, not doscall
	jmp short .done
%if _VDD
.vdd:
	mov ax, word [hVdd]
	mov cx, 5
%if _PM
	add cl, byte [dpmi32]
%endif
	DispatchCall
	jmp short .done
%endif
.oldint:
	int 25h
.done:
	mov dx, reading
	jmp ww1

		; For .COM or .EXE files, we can only load at cs:100.  Check that first.
ll1:
	test byte [fileext], EXT_COM| EXT_EXE
	jz ll4			; if not .COM or .EXE file
	cmp bx, word [reg_cs]
	jne ll2			; if segment is wrong
	cmp dx, 100h
	je ll4			; if address is OK (or not given)
ll2:
	jmp error		; can only load .COM or .EXE at cs:100

		; load (any) file (if not .EXE or .COM, load at BX:DX)
ll3:
	cmp byte [fileext], 0
	jne ll4
	retn

		; open file and get length
ll4:
	mov si, bx		; save destination address, segment
	mov di, dx		; and offset
	mov ax, 3D00h		; open file for reading
	mov dx, DTA
	doscall
	jc ll16			; error
	xchg ax, bx		; mov bx, ax
	mov ax, 4202h		; lseek
	xor cx, cx
	xor dx, dx
	int 21h

;	Split off file types
;	At this point:
;		bx	file handle
;		dx:ax	file length
;		si:di	load address (CS:100h for .EXE or .COM)

	test byte [fileext], EXT_COM | EXT_EXE
	jnz ll13		; if .COM or .EXE file

%if _PM
;--- dont load a file in protected mode,
;--- the read loop makes some segment register arithmetic
	call ispm
	jnz .rm
	mov dx, nopmsupp
	call putsz
	jmp ll12
.rm:
%endif

		; Load it ourselves.
		; For non-.com/.exe files, we just do a read, and set BX:CX to the
		; number of bytes read.

	call ensuredebuggeeloaded	; make sure a debuggee is loaded
	mov es, word [pspdbe]

		; Check the size against available space.
	push	si
	push	bx

	cmp si, word [es:ALASAP]
	pushf
	neg si
	popf
	jae ll6				; if loading past end of mem, allow through ffff
	add si, word [es:ALASAP]	; si = number of paragraphs available
ll6:
	mov cx, 4
	xor bx, bx
ll7:
	shl si, 1
	rcl bx, 1
	loop ll7
	sub si, di
	sbb bx, cx			; bx:si = number of words left
	jb ll9				; if already we're out of space
	cmp bx, dx
	jne ll8
	cmp si, ax
ll8:
	jae ll10			; if not out of space
ll9:
	pop bx				; out of space
	pop si
	mov dx, doserr8			; not enough memory
	call putsz			; print string
	jmp short ll12

ll10:
	pop	bx
	pop	si

;	Store length in registers

; seems a bit unwise to modify registers if a debuggee is running
; but MS DEBUG does it as well

%if 0
	mov cx,[reg_cs]
	cmp cx,[pspdbe]
	jnz .noregmodify
	cmp word [reg_eip], 100h
	jnz .noregmodify
%endif
	mov word [reg_ebx], dx
	mov word [reg_ecx], ax
.noregmodify:

		; Rewind the file
	mov ax, 4200h		; lseek
	xor cx, cx
	xor dx, dx
	int 21h

	mov dx, 0Fh
	and dx, di
	mov cl, 4
	shr di, cl
	add si, di		; si:dx is the address to read to

		; Begin loop over chunks to read
ll11:
	mov ah, 3Fh		; read from file into DS:(E)DX
	mov cx, 0FE00h		; read up to this many bytes
	mov ds, si
	int 21h

	add	si,0fe0h	;wont work in protected-mode!
	cmp	ax,cx
	je	ll11		;if end of file reached

;	Close the file and finish up.

ll12:
	mov ah, 3Eh		; close file
	int 21h
	push ss			; restore ds
	pop ds
	retn			; done

ll13:
		; file is .EXE or .COM
		; Close the file

	push ax
	mov ah, 3Eh		; close file
	int 21h
	pop bx			; dx:bx is the file length

%if 1

		; adjust .exe size by 200h (who knows why)
		; cm: this is wrong. It needs to be adjusted by the header size,
		; which is stored (as number of paragraphs) in the .EXE header.
		; The header size is often 200h, but not always.
	test byte [fileext], EXT_EXE
	jz ll14			; if not .EXE
	sub bx, 200h
	sbb dx, 0
%endif

		; Clear registers

ll14:
	push bx
	push dx
;	mov word [reg_ebx], dx
;	mov word [reg_ecx], bx

;--- cancel current process (unless there is none)
;--- this will also put cpu back in real-mode!!!

	call terminate_attached_process
	jz ll_attached_unterminated

	mov di, regs
	mov cx, 16*2	;(8 std, 6 seg, ip, fl) * 2
	xor ax, ax
	rep stosw

	pop word [reg_ebx]
	pop word [reg_ecx]

		; Fix up interrupt vectors in PSP
	mov si, CCIV		; address of original INT 23 and 24 (in PSP)
	mov di, run2324
	movsw
	movsw
	movsw
	movsw

		; Actual program loading.  Use the DOS interrupt.
	mov ax, 4B01h		; load program
	mov dx, DTA		; offset of file to load
	mov bx, execblk		; parameter block
	int 21h			; load it
	jc ll16			; if error
	mov ax, sp
	sub ax, [SPSAV]
	cmp ax, 80h
	jb ll15			; if in range
	mov ax, 80h
ll15:
	mov word [spadjust], ax
	les si, [execblk+14]
	es lodsw		; recover ax
	mov word [reg_eax], ax
	mov word [reg_esp], si
	mov word [reg_ss], es
	les si, [execblk+18]
	mov word [reg_eip], si
	mov word [reg_cs], es
	mov byte [bInit],0
	push cs
	pop es
	call set_efl_to_fl
	call getpsp
	mov ax, bx
	mov word [pspdbe], ax
	clropt [internalflags], attachedterm
	mov di, reg_ds
	stosw
	scasw
	stosw			; reg_es
	call setpspdbg

		; Finish up. Set termination address.
	mov ax, 2522h		; set interrupt vector 22h
	mov dx, int22
	int 21h
	mov ds, word [pspdbe]
	mov word [TPIV], dx
	mov word [TPIV+2], cs
	push cs
	pop ds

		; Set up initial addresses for 'a', 'd', and 'u' commands.
adusetup:
	mov ax, word [reg_eip]
	mov cx, word [reg_eip+2]
	mov bx, word [reg_cs]
	mov di, a_addr
	stosw			; IP
	mov word [di], cx
	scasw			; skip this word
	xchg ax, bx
	stosw			; CS
	xchg ax, bx		; d_addr
	stosw			; IP
	mov word [di], cx
	scasw
	xchg ax, bx
	stosw			; CS
	xchg ax, bx		; u_addr
	stosw			; IP
	mov word [di], cx
	scasw
	xchg ax, bx
	stosw			; CS
	retn

		; Error messages.  Print and quit.
ll16:
	jmp ww15		; print error message

ll_attached_unterminated:
	mov dx, msg.ll_unterm
	jmp putsz

		; M command - move from place to place.
		;
		; first check if there is more than 1 argument
		; 0 or 1 arguments are handled by the 'M [cpu]' code
mm:
%if 0
	push si
	cmp al, ';'
	je mc
	cmp al, 13
	je mc			; no argument, CPU-related M command
	mov ah, byte [ si ]
	push ax
	and ax, ~(2020h)
	cmp ax, "NC"
	pop ax
	je mc
	call getdword
	cmp al, ';'
	je mc
	cmp al, 13
	je mc			; one argument, CPU-related
	cmp al, 32
	je .blank		; end of first argument
	cmp al, 9
	jne .nonblank		; not end of first argument
.blank:
%else
	push si
	cmp al, ';'
	je mc
	cmp al, ';'
	je mc
	cmp al, 13
	je mc			; no argument, CPU-related M command
.nonblank:
	lodsb			; is a non-space and non-CR ?
	cmp al, ';'
	je mc
	cmp al, 13
	je mc			; one argument, CPU-related
	cmp al, 32
	je .blank		; end of first argument
	cmp al, 9
	jne .nonblank		; not end of first argument
.blank:
%endif
	call skipwh0		; skip blanks behind argument
	cmp al, ';'
	je mc
	cmp al, 13
	je mc			; one argument, CPU-related
	pop si
	dec si
	lodsb
			; It is a normal M command (Move)
	call parsecm		; parse arguments (DS:ESI, ES:EDI, ECX)
	push cx
%if _PM
	call ispm
	jnz .rm
	mov ax, ds
	mov cx, es
	cmp ax, cx
	je .pmsimple		; same selector, simple -->

	mov ax, 0006h
	mov bx, ds
	int 31h			; get selector's base
	jc error
	push cx
	push dx
	mov ax, 0006h
	mov bx, es
	int 31h			; get selector's base
	jc error		; throw
	cmp byte [ss:bAddr32], 0
	je .pm16
[cpu 386]
	pop eax
	push cx
	push dx
	pop edx			; mov edx, cxdx
	add eax, esi		; add offset to source selector's base
	jc error
	add edx, edi		; add offset to destination selector's base
	jc error		; if overflow (> 4 GiB) -->
	cmp eax, edx		; compare linear source to linear destination
	jmp short m3		; and decide whether to move up or down -->
__CPU__

.rm:
	mov ax, ds
	mov bx, ds
	mov dx, es
	mov cl, 12
	shr bx, cl
	shr dx, cl
	push dx
	mov dx, es
	mov cl, 4
	shl ax, cl
	shl dx, cl
	pop cx
	db __TEST_IMM16		; (skip 2 pop instructions)

.pm16:
	pop ax
	pop bx
	add ax, si
	adc bx, byte 0		; add offset to source selector's base
	jc error
	add dx, di
	adc cx, byte 0		; add offset to destination selector's base
	jc error		; if overflow (> 4 GiB) -->
	cmp bx, cx		; compare linear source to linear destination
	jne m3
	cmp ax, dx
	jmp short m3		; and decide whether to move up or down -->

.pmsimple:
	_386_o32	; cmp esi, edi
	cmp si, di
%else
	mov dx, di
	mov bx, es
	mov cl, 4
	shr dx, cl
	add dx, bx		; upper 16 bits of destination
	mov ax, si
	shr ax, cl
	mov bx, ds
	add ax, bx
	cmp ax, dx
	jne m3			; if we know which is larger
	mov ax, si
	and al, 0Fh
	mov bx, di
	and bl, 0Fh
	cmp al, bl
%endif
m3:	pop cx
	lahf
	push ds
	push es
	push ss			; ds := cs
	pop ds
	call dohack		; do the interrupt pointer hack
	pop es
	pop ds
	sahf
	jae .forward		; if forward copy is OK
	_386_PM_o32
	add si, cx
	_386_PM_o32
	add di, cx		; point both behind data
	std
.forward:
	_386_PM_a32
	rep movsb		; do the move
	_386_PM_a32
	movsb			; one more byte (length of zero means 64 KiB. or 4 GiB..)
.was32:
	cld			; restore flag
	jmp ee0a		; restore segments and undo the interrupt pointer hack


		; Other M command: set machine type.
mc:
	pop si
	dec si
	lodsb
	cmp al, 13
	je m10			; if just an 'm' (query machine type)
	cmp al, '?'
	je m10			; if '?' (also query)
	cmp al, '0'
	jb mc1			; if not a digit
	cmp al, '6'
	ja mc1			; ditto
	sub al, '0'
	mov byte [machine], al	; set machine type
	mov byte [mach_87], al	; coprocessor type, too
	retn

mc1:	or al, TOLOWER
	cmp al, 'c'
	je mcc			; if coprocessor declaration
	cmp al, 'n'
	jne short errorj3	; if something else
	lodsb
	or al, TOLOWER
	cmp al, 'c'
	jne short errorj3	; if not 'c' after that
	lodsb
	call chkeol
	mov byte [has_87], 0	; clear coprocessor flag
	retn			; done

mcc:
	call skipwhite		; get next nonblank character
	mov ah, byte [machine]
	cmp ah, 3
	jne mcc2		; if not a 386
	cmp al, '3'
	je mcc1			; if declaring a 387
	cmp al, '2'
	jne mcc2		; if not '2'
	mov ah, 2
mcc1:
	call skipwhite
mcc2:
	call chkeol
	mov byte [has_87], 1	; set coprocessor flag
	mov byte [mach_87], ah	; set copr. type
	retn

		; Display machine type.
m10:
	mov si, msg8088
	mov al, byte [machine]
	cmp al, 0
	je .88or86		; if 8088
	mov si, msgx86
	add al, '0'
	mov byte [si], al
.88or86:
	call showstring
	mov si, no_copr
	cmp byte [has_87], 0
	je m12			; if no coprocessor
	mov si, has_copr
	mov al, byte [mach_87]
	cmp al, byte [machine]
	je m12			; if has coprocessor same as processor
	mov si, has_287
m12:
	call showstring		; show string
	jmp putsline_crlf	; call puts and quit

errorj3:
	jmp error


		; N command - change the name of the program being debugged.
nn:	mov	di, DTA		; destination address

		; Copy and canonicalize file name.
nn1:
	cmp al, 13
	je nn3			; if end of line
	call ifsep		; check for separators blank, tab, comma, ;, =
	je nn3			; if end of file name
	cmp al, byte [swch1]
	je nn3			; if '/' (and '/' is the switch character)
	call uppercase
	stosb
	lodsb
	jmp short nn1		; back for more

nn3:
	mov al, 0		; null terminate the file name string
	stosb
	mov word [execblk+2], di; save start of command tail

		; Determine file extension
	cmp di, DTA+1
	je nn3d			; if no file name at all
	cmp di, DTA+5
	jb nn3c			; if no extension (name too short)
	mov al, EXT_HEX
	cmp word [di-5], ".H"
	jne nn3a		; if not .HEX
	cmp word [di-3], "EX"
	je nn3d			; if .HEX
nn3a:
	mov al, EXT_EXE
	cmp word [di-5], ".E"
	jne nn3b		; if not .EXE
	cmp word [di-3], "XE"
	je nn3d			; if .EXE
nn3b:
	mov al, EXT_COM
	cmp word [di-5], ".C"
	jne nn3c		; if not .COM
	cmp word [di-3], "OM"
	je nn3d			; if .COM
nn3c:
	mov al, EXT_OTHER
nn3d:
	mov byte [fileext], al

		; Finish the N command
	push di
	mov di, line_out
	dec si
nn4:
	lodsb			; copy the remainder to line_out
	stosb
	cmp al, 13
	jne nn4

		; Set up FCBs.
	mov si, line_out
	mov di, 5Ch
	call nn6		; do first FCB
	mov byte [reg_eax], al
	mov di, 6Ch
	call nn6		; second FCB
	mov byte [reg_eax+1], al

		; Copy command tail.
	mov si, line_out
	pop di
	push di
	inc di
nn5:
	lodsb
	stosb
	cmp al, 13
	jne nn5			; if not end of string
	push di
	mov cx, di
	sub cx, DTA+128
	neg cx
	xor ax, ax
	rep stosb
	pop di
	pop ax			; recover old DI
	xchg ax, di
	sub ax, di		; compute length of tail
	dec ax
	dec ax
	stosb
	retn			; done

		; Subroutine to process an FCB.
nn6:
	lodsb
	cmp al, 13
	je nn7			; if end
	call ifsep
	je nn6			; if separator
	cmp al, byte [switchar]
	je nn10			; if switch character
nn7:
	dec si
	mov ax, 2901h		; parse filename
	doscall
	push ax			; save AL
nn8:
	lodsb			; skip till separator
	cmp al, 13
	je nn9			; if end
	call ifsep
	je nn9			; if separator character
	cmp al, byte [swch1]
	jne nn8			; if not switchar (sort of)
nn9:
	dec si
	pop ax			; recover AL
	cmp al, 1
	jne nn9a		; if not 1
	dec ax
nn9a:
	retn

		; Handle a switch (differently).
nn10:	lodsb
	cmp al, 13
	je nn7			; if end of string
	call ifsep
	je nn10			; if another separator
	mov al, 0
	stosb
	dec si
	lodsb
	cmp al, 'a'
	jb nn11			; if not a lower case letter
	cmp al, 'z'
	ja nn11
	and al, TOUPPER		; convert to upper case
nn11:	stosb
	mov ax, 32<<8|32
	stosw
	stosw
	stosw
	stosw
	stosw
	xor ax, ax
	stosw
	stosw
	stosw
	stosw
	retn			; return with al = 0


;--- ensure segment in BX is writeable
;--- out: CY if segment not writeable
;--- might clear HiWord(EDI)

%if _PM
verifysegm:
	call ispm
	jnz is_rm		; (NC)
	push ax
	push di
	push bp
	mov bp, sp
	sub sp, 8
	mov di, sp
_386	movzx edi, di
	mov ax, 000Bh		; get descriptor
	int 31h
	jc vs_2
	test byte [di+5], 8	; code segment
	jz vs_2
	and byte [di+5], 0F3h	; reset CODE+conforming attr
	or byte [di+5], 2	; set writable
	mov bx, word [scratchsel]
	mov ax, 000Ch
	int 31h
vs_2:
	mov sp, bp
	pop bp
	pop di
	pop ax
is_rm:
	retn

cpu 286
setrmsegm:
	mov bx, word [ss:scratchsel]
setrmaddr:		;<--- set selector in BX to segment address in DX
	mov cx, dx
	shl dx, 4
	shr cx, 12
	mov ax, 7
	int 31h
	retn
__CPU__
%endif

		; Read a byte relative to cs:eip
		;
		; INP:	reg_cs, reg_eip
		;	cx = (signed) eip adjustment
		; OUT:	al = byte at that address
		;	(e)bx = new offset (eip+adjustment)
		; CHG:	-
getcseipbyte:
	push es
%if _PM
	mov bx, word [reg_cs]
	mov es, bx
	call testattrhigh
	jz .16
cpu 386
	mov ebx, dword [reg_eip]
	push edx
	movsx edx, cx
	add ebx, edx
	mov al, byte [es:ebx]
	pop edx
	pop es
	retn
cpu 8086
.16:
%else
	mov es, word [reg_cs]
%endif
	mov bx, word [reg_eip]
	add bx, cx
	mov al, byte [es:bx]
	pop es
	retn

		; Write to a byte relative to cs:eip
		;
		; INP:	reg_cs, reg_eip
		;	cx = (signed) eip adjustment
		; OUT:	al = byte at that address
		; CHG:	(e)bx
setcseipbyte:
	push es
%if _PM
	mov bx, word [reg_cs]
	call verifysegm
	jc .ret
	mov es, bx
	call testattrhigh
	jz .16
cpu 386
	mov ebx, dword [reg_eip]
	push edx
	movsx edx, cx
	mov byte [es:ebx+edx],al
	pop edx
	pop es
	retn
cpu 8086
.16:
%else
	mov es, word [reg_cs]
%endif
	mov bx, word [reg_eip]
	add bx, cx
	mov byte [es:bx], al
.ret:
	pop es
	retn

		; Exchange byte with memory
		;
		; INP:	bx:(e)dx-> destination byte
		;	al = source byte
		; OUT:	CY if failed due to segment not writable
		;	NC if successful,
		;	 al = previous value of destination byte
		; CHG:	ah
writemem:
	mov ah, al
%if _PM
	call ispm
	jnz .16			; (NC from ispm) -->
	call verifysegm		; make bx a writeable segment
	jc .ret
	call testattrhigh
	jz .16			; (NC from testattrhigh) -->
cpu 386
	push ds
	mov ds, bx
	xchg al, byte [edx]
	cmp ah, byte [edx]
	pop ds
cpu 8086
	jmp short .cmp
.16:
%endif
	push ds
	mov ds, bx
	push bx
	mov bx, dx
	xchg al, byte [bx]
	cmp ah, byte [bx]
	pop bx
	pop ds
.cmp:
	je .ret			; (NC)
	stc			; Failed to compare (i.e. memory wasn't our byte after writing).
				; This check catches ROM that will silently fail to write.
.ret:
	retn


;--- read byte at BX:EDX into AL

readmem:
%if _PM
	call testattrhigh
	jz .16
	push ds
	mov ds, bx
	mov al, byte [edx]
	pop ds
	retn
.16:
%endif
	push ds
	push bx
	mov ds, bx
	mov bx, dx
	mov al, byte [bx]
	pop bx
	pop ds
	retn


		; Q command - quit.
qq:
%if _PM
 %if _BOOTLDR
		; Test whether we are in non-DOS mode, and were
		; currently entered in protected mode. Since
		; this will make the entire operation fail,
		; it has to be checked for before modifying
		; or releasing any of the resources.
		; (Does this ever occur? No?)
	testopt [internalflags], nodosloaded
	jz .notpmnodos
	call ispm
  %if _TSR	; same message, reuse code
	jz .cannotpmquit
  %else
	jnz .notpmnodos
	mov dx, msg.cannotpmquit
	jmp putsz
  %endif
.notpmnodos:
 %endif
 %if _TSR
		; Test whether we are in TSR mode, and were
		; currently entered in protected mode. Since
		; this will make the entire operation fail,
		; it has to be checked for before modifying
		; or releasing any of the resources.
	testopt [internalflags], tsrmode
	jz .notpmtsr
	call ispm
	jnz .notpmtsr

; This isn't yet implemented. Broken down:
; * Uses terminate_attached_process which returns in real mode.
;  * Exception vectors are implicitly restored/discarded by that.
; * (RM) Interrupt vectors are currently restored in real mode. Unnecessary.
; * The VDD is un-registered in real mode. Necessary?
; * Normal 21.4C is used to return to the real parent.
;  * We have to discard our DOS process resources. Any DPMI TSR resources?
;  * We must again gain control in debuggee's mode after discarding them.
;  * We must return to the debuggee and seemlessly discard our memory. The
;    stack trick possibly/probably does not work in protected mode.

.cannotpmquit:
	mov dx, msg.cannotpmquit
	jmp putsz

.notpmtsr:
 %endif

 %if (nohook2F)&~0FF00h
  %fatal Internal flags re-ordered, adjust code here
 %endif
	mov ax, [internalflags]
 	mov al, __TEST_IMM8
	xchg al, [dpmidisable]		 	; disable DPMI hook
	push ax
	setopt [internalflags], nohook2F	; avoid a new hook while terminating
%endif
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jnz .restoreints
%endif

		; Cancel child's process if any.
		; This will drop to real mode if debuggee is in protected mode.
%if _TSR
	testopt [internalflags], tsrmode
	jnz .restoreints
%endif

	call terminate_attached_process
	jz qq_attached_unterminated

.restoreints:
	pop ax					; (discard)
		; Restore interrupt vectors.
	mov di, intsave
	mov si, inttab
	mov cx, inttab_number
.nextint:
	lodsb
%if _BOOTLDR
	xor bx, bx
%endif
	mov bl, al
	inc si
	inc si
	xchg si, di
	lodsw
	mov dx, ax
	lodsw
	xchg si, di
	; cmp dx, byte -1
	; je .norestore
	push ds
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jz .int21_25
	push ax
	push dx
	xor ax, ax
	mov ds, ax
	add bx, bx
	add bx, bx
	pop word [ bx ]
	pop word [ bx+2 ]
	jmp short .popds
.int21_25:
%endif
	mov ds, ax
	mov al, bl
	mov ah, 25h
	int 21h
.popds:
	pop ds
.norestore:
	loop .nextint

%if _PM
	testopt [internalflags], hooked2F
	jz .noint2F
	push ds
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jz .int21_25_2f
	push word [oldi2F+2]
	push word [oldi2F]
	xor ax, ax
	mov ds, ax
	pop word [2Fh*4]
	pop word [2Fh*4+2]
	jmp short .popds2f
.int21_25_2f:
%endif
	mov ax, 252Fh
	lds dx, [oldi2F]
	int 21h
.popds2f:
	pop ds
.noint2F:
%endif

		; Release the registered VDD.
%if _VDD
	testopt [internalflags], ntpacket
	jz .novdd
	mov ax, word [hVdd]
	UnRegisterModule
.novdd:
%endif

		; Restore termination address.
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jz .dosterminate	; terminate -->
	int 19h			; reboot
	jmp 0FFFFh:0
.dosterminate:
%endif
%if _TSR
	testopt [internalflags], tsrmode
	jz .nontsrterminate
	xor si, si
	mov di, auxbuff
	xor ax, ax
	mov cx, 8
	rep stosw
	mov cx, 40h
	rep movsw
	mov ax, cs
	add ax, (auxbuff+16-section.DATASTACK.vstart+100h+ldebug_size+asmtable1_size+asmtable2_size)>>4
	mov word [auxbuff+1], ax; fake MCB
	push ds
	mov ds, ax
	mov word [34h], 18h
	mov word [36h], ax	; insure default PHT and fix segment
	mov word [32h], 1	; only one PHT entry (zero might crash)
	mov byte [18h], -1	; PHT entry is closed
	mov word [2Ch], 0	; PSP clear
	call .setparent		; make it self-owned, just in case
	mov bx, cs
	dec bx
	mov ds, bx		; => our (real) MCB
	mov word [1], ax	; parent = fake PSP
	pop ds
	call .setparent		; make the fake PSP our parent
	jmp short terminate	; see ya

.nontsrterminate:
%endif
	mov si, psp22		; restore termination address
	mov di, TPIV
	movsw
	movsw
	mov di, 16h		; restore PSP of parent
	movsw
		; Really done.
terminate:			; re-used by terminate_attached_process
	mov ax, 4C00h		; quit
	int 21h


qq_attached_unterminated:
		; Restore state:
%if _PM
 %if (nohook2F)&~0FF00h
  %fatal Internal flags re-ordered, adjust code here
 %endif
 	pop ax
	mov [dpmidisable], al
	and ah, nohook2F>>8
	clropt [internalflags], nohook2F
	or [internalflags+1], ah
%endif
	mov dx, msg.qq_unterm
	jmp putsz


%if _TSR
qq.proceedtsrtermination:
	cli
	mov ax, cs
	mov ds, ax
	mov ss, ax
	mov sp, stack_end
	sti
	sub word [reg_esp], 2+4+((qq.tsrfreecode_size+1)&~1)
	mov di, word [reg_esp]	; -> stack frame
	mov es, word [reg_ss]
	mov ax, word [reg_ds]
	stosw			; debuggee's ds
	mov ax, word [reg_eip]
	stosw
	mov ax, word [reg_cs]
	stosw			; debuggee's cs:ip
	push es
	push di
	mov si, qq.tsrfreecode
	mov cx, ((qq.tsrfreecode_size+1)>>1)
	rep movsw		; code on stack
	mov ax, cs
	dec ax
	mov word [reg_ds], ax	; = our MCB
	pop word [reg_eip]
	pop word [reg_cs]	; -> code on stack
%if _DEBUG
		; avoid hooking interrupts again:
	mov byte [..@patch_tsr_quit_run], __JMP_REL8
%endif
	jmp run			; run this

	; Note that since we are in control of debuggee's TF and
	; reset it every time the debugger is entered, this code
	; will not be entered with TF set. It might be entered
	; with IF set and an interrupt might occur; the only harm
	; done then is that the interrupt handler has less stack
	; available. All flags must be preserved by this code.
qq.tsrfreecode:
	mov word [1], 0		; free the MCB
	pop ds			; restore debuggee's ds
	retf ((qq.tsrfreecode_size+1)&~1)	; jump
qq.tsrfreecode_size: equ $-qq.tsrfreecode

qq.setparent:
	mov word [16h], ax
	mov word [0Ah], qq.proceedtsrtermination
	mov word [0Ah+2], cs
	retn
%endif

		; S command - search for a string of bytes.
sss:
	mov bx, word [reg_ds]	; get search range
	_386_PM_o32		; xor ecx, ecx
	xor cx, cx
	_386_PM_o32
	mov word [sscounter], cx; mov dword [sscounter], ecx
	call getrangeX		; get address range into BX:(E)DX..BX:(E)CX
	call skipcomm0
	_386_PM_o32		; push edx
	push dx
	_386_PM_o32		; push ecx
	push cx
	push bx
	push ax
	push si
	push word [throwret]
	push word [throwsp]
	mov word [throwret], .catch
	mov word [throwsp], sp
	mov bx, word [reg_ds]	; get search range
	xor cx, cx
	call getrangeX		; try to get second range
	call chkeol		; and insure end-of-line
				; successful if it returned
	pop word [throwsp]
	pop word [throwret]	; restore throw destination
	add sp, byte 4		; discard ax/si
	_386_PM_o32		; mov esi, edx
	mov si, dx		; bx:esi-> source string
	_386_PM_o32		; sub ecx, edx
	sub cx, dx		; ecx = count - 1
	jmp short .setesedi

.catch:				; second getrangeX failed
	mov sp, word [throwsp]	; restore stack
	pop word [throwsp]
	pop word [throwret]	; restore throw destination
	pop si
	pop ax			; restore line
	call getstr		; get string of bytes
	sub di, line_out	; di = number of bytes to look for
	mov cx, di
	dec di			;     minus one
	mov si, line_out
	push di
	mov di, auxbuff
	rep movsb		; move to auxbuff
	mov si, auxbuff
	pop cx
	mov bx, ds		; bx:esi-> auxbuff
_386_PM	movzx esi, si
_386_PM	movzx ecx, cx		; ecx = count - 1
.setesedi:
	call prephack		; set up for the interrupt vector hack
	call dohack
	mov ds, bx
	pop es
	_386_PM_jmpn .386init	; 386 -->
.init:
	pop bx
	pop dx
.init_popped:
	sub bx, dx		; bx = number of bytes in search range minus one
	sub bx, cx		; = number of possible positions of string minus 1
	jb error
	mov di, dx
	mov dx, cx
	mov cx, bx

		; ds:si-> search string, length (dx+1)
		; es:di-> data to search in, (cx+1) bytes
.loop:
	or al, 1		; NZ (iff cx==0, repne scasb doesn't change ZF)
	push si
	lodsb			; first character in al
	repne scasb		; look for first byte
	je .foundbyte
	scasb			; count in cx was cnt-1
	jne .done
.foundbyte:
	push cx
	push di
	mov cx, dx
	repe cmpsb		; compare string behind first byte
	pop di
	je .display		; if equal
.next:
	pop cx
	pop si
	inc cx			; increase first because loop decreases it
	loop .loop		; go back for more
	db __TEST_IMM8		; (skip pop)
.done:
	pop si			; discard
.commondone:
	push ss
	pop ds
	call unhack
	mov di, line_out
%if _PM
	mov ax, word [sscounter+2]
	test ax, ax
	jnz .nohighcounter
	call hexword
.nohighcounter:
%endif
	mov ax, word [sscounter]
	call hexword
	call putsline
	mov dx, msg.matches
	jmp putsz

.display:
	mov bx, es
	push di
	push ds
	push es
	 push ss
	 pop ds	
	call unhack		; undo the interrupt vector hack and restore es
	inc word [sscounter]
	push di
	mov ax, bx
	mov di, line_out
	call hexword		; 4 (segment)
	mov al, ':'
	stosb			; +1=5
	pop ax
	dec ax
	call hexword
%if _SDUMP
	stc
	adc ax, dx		; -> behind result
	jbe .noresult		; end of segment
	mov si, ax
	mov ax, 32<<8|32
	stosw
	lea bx, [di+3*16]
	mov cx, si
	neg cx
	cmp cx, byte 16
	jbe .cxdone
	mov cx, 16
.cxdone:
	 pop ds
	 push ds		; restore search's segment
	push cx
.disploop:
	lodsb
	call dd_store
	loop .disploop
	pop cx
	 push ss
	 pop ds
	neg cx
	add cx, byte 16
	jz .noblanks
.loopblanks:
	mov ax, 32<<8|32
	stosw
	stosb
	loop .loopblanks
.noblanks:
	mov byte [di-(1+(8*3))], '-'
	mov di, bx
.noresult:
%endif	; _SDUMP
	push dx
	call putsline_crlf
	call dohack
	pop dx
	pop es
	pop ds
	pop di
	jmp .next

%if _PM
.386init:
cpu 386
	pop ebx
	pop edx
	call ispm
	jnz .init_popped	; not PM -->
	sub ebx, edx		; ebx = number of bytes in search range minus one
	sub ebx, ecx		; = number of possible positions of string minus 1
	jb error
	mov edi, edx
	mov edx, ecx
	mov ecx, ebx

		; ds:esi-> search string, length (edx+1)
		; es:edi-> data to search in, (ecx+1) bytes
		; Although 386+ RM still uses 64 KiB segments, it allows
		; us to use the 32-bit addressing variant of the string
		; instructions as long as we never access any byte above
		; the 64 KiB limit. (Even if the index register contains
		; 00010000h after an instruction executed.)
.386loop:
	or al, 1		; NZ (iff cx==0, repne scasb doesn't change ZF)
	push esi
	a32 lodsb		; first character in al
	a32 repne scasb		; look for first byte
	je .386foundbyte
	a32 scasb		; count in ecx was cnt-1
	jne .386done
.386foundbyte:
	push ecx
	push edi
	mov ecx, edx
	a32 repe cmpsb		; compare string behind first byte
	pop edi
	je .386display		; if equal
.386next:
	pop ecx
	pop esi
	inc ecx			; increase first because loop decreases it
	loop .386loop, ecx	; go back for more
	db __TEST_IMM16		; (skip pop)
.386done:
	pop esi			; discard
	jmp .commondone

.386display:
	mov bx, es
	push edi
	push ds
	push es
	call unhack		; undo the interrupt vector hack and restore es
	inc dword [sscounter]
	push edi
	mov ax, bx
	mov di, line_out
	call hexword		; 4 (segment)
	mov al, ':'
	stosb			; +1=5
	pop eax
	dec eax
	call testattrhigh
	jz .noa32
	call hexword_high
.noa32:
	call hexword
%if _SDUMP
	stc
	adc eax, edx		; -> behind result
	jbe .386noresult	; end of segment
	mov esi, eax
	mov ax, 32<<8|32
	stosw
	lea bx, [di+3*16]
	mov ecx, esi
	neg ecx
	cmp ecx, byte 16
	jbe .386cxdone
	mov cx, 16
.386cxdone:
	 pop ds
	 push ds		; restore search's segment
	push cx
.386disploop:
	a32 lodsb
	call dd_store
	loop .386disploop
	pop cx
	 push ss
	 pop ds
	neg cx
	add cx, byte 16
	jz .386noblanks
.386loopblanks:
	mov ax, 32<<8|32
	stosw
	stosb
	loop .386loopblanks
.386noblanks:
	mov byte [di-(1+(8*3))], '-'
	mov di, bx
.386noresult:
%endif	; _SDUMP
	push dx
	call putsline_crlf
	call dohack
	pop dx
	pop es
	pop ds
	pop edi
	jmp .386next
cpu 8086
%endif	; _PM


lockdrive:
	push ax
	push bx
	push cx
	push dx
	mov bl, al
	inc bl
	mov bh, 0
	mov cx, 084Ah
	mov dx, 0001h
	mov ax, 440Dh
	int 21h
	pop dx
	pop cx
	pop bx
	pop ax
	retn

unlockdrive:
	push ax
	push bx
	push cx
	push dx
	mov bl, al
	inc bl
	mov bh, 0
	mov cx, 086Ah
	mov dx, 0001h
	mov ax, 440Dh
	int 21h
	pop dx
	pop cx
	pop bx
	pop ax
	retn


		; W command - write a program, or disk sectors, to disk.
ww:
	call parselw		; parse L and W argument format
	jz ww4			; if request to write program
%if _PM && _NOEXTENDER
	call ispm
	jnz .rm
	call isextenderavailable
	jc nodosextinst
.rm:
%endif
	testopt [ss:internalflags], newpacket| ntpacket
	jz .oldint
	mov dl, al		; A: = 0, ...
	mov si, 6001h		; write, assume "file data"
%if _VDD
	testopt [internalflags], ntpacket
	jnz .vdd
%endif
	inc dl			; A: = 1, ...
	call lockdrive
	mov ax, 7305h		; ds:(e)bx-> packet
	stc
	int 21h			; use int 21h here, not doscall
	pushf
	call unlockdrive
	popf
	jmp short .done
%if _VDD
.vdd:
	mov ax, word [hVdd]
	mov cx, 5
%if _PM
	add cl, byte [dpmi32]
%endif
	DispatchCall
	jmp short .done
%endif
.oldint:
	int 26h
.done:
	mov dx, writing
ww1:
	mov bx, ss		; restore segment registers
	mov ds, bx
	mov sp, word [savesp]
	mov es, bx
	jnc ww3			; if no error
	cmp al, 0Ch
	jbe ww2			; if in range
	mov al, 0Ch
ww2:
	cbw			; ah = 0
	mov bx, dskerrs		; -> byte table
	xlatb			; get offset from dskerrs
	add ax, bx		; -> message
	mov di, line_out
	mov si, ax
	call showstring
	mov si, dx
	call showstring
	mov si, drive
	call showstring
	call putsline_crlf
ww3:
	jmp cmd3		; can't return because Int26 leaves stack wrong

;	Write to file.  First check the file extension.
;   size of file is in client's BX:CX,
;   default start address is DS:100h

ww4:
	mov al, byte [fileext]	; get flags of file extension
	test al, EXT_EXE + EXT_HEX
	jz ww5			; if not EXE or HEX
	mov dx, nowhexe
	jmp short ww6

ww5:
	cmp al, 0
	jnz ww7			; if extension exists
	mov dx, nownull
ww6:
	jmp ww16

		; File extension is OK; write it.  First, create the file.
ww7:
%if _PM
	call ispm
	jnz ww7_1
	mov dx, nopmsupp
	jmp putsz
ww7_1:
%endif
	mov bp, line_out
	cmp dh, 0FEh
	jb ww8			; if (dx < 0xFE00)
	sub dh, 0FEh		;  dx -= 0xFE00;
	add bx, 0FE0h
ww8:
	mov word [bp+10], dx	; save lower part of address in line_out+10
	mov si, bx		; upper part goes into si
	mov ah, 3Ch		; create file
	xor cx, cx		; no attributes
	mov dx, DTA
	doscall
	jc ww15			; if error
	push ax			; save file handle

		; Print message about writing.
	mov dx, wwmsg1
	call putsz		; print string
	mov ax, word [reg_ebx]
	cmp ax, 10h
	jb ww9			; if not too large
	xor ax, ax		; too large:  zero it out
ww9:
	mov word [bp+8], ax
	test ax, ax
	jz ww10
	call hexnyb
ww10:
	mov ax, word [reg_ecx]
	mov word [bp+6], ax
	call hexword
	call putsline		; print size
	mov dx, wwmsg2
	call putsz		; print string

		; Now write the file.  Size remaining is in line_out+6.
	pop bx			; recover file handle
	mov dx, word [bp+10]	; address to write from is si:dx
ww11:
	mov ax, 0FE00h
	sub ax, dx
	cmp byte [bp+8], 0
	jnz ww12		; if more than 0FE00h bytes remaining
	cmp ax, word [bp+6]
	jb ww12			; ditto
	mov ax, word [bp+6]
ww12:
	xchg ax, cx		; mov cx, ax
	mov ds, si
	mov ah, 40h		; write to file
	int 21h			; use INT, not doscall
	push ss			; restore DS
	pop ds
	cmp ax, cx
	jne ww13		; if disk full
	xor dx, dx		; next time write from xxxx:0
	add si, 0FE0h		; update segment pointer
	sub word [bp+6], cx
	lahf
	sbb byte [bp+8], 0
	jnz ww11		; if more to go
	sahf
	jnz ww11		; ditto
	jmp short ww14		; done

ww13:
	mov dx, diskful
	call putsz		; print string
	mov ah, 41h		; unlink file
	mov dx, DTA
	doscall

		; Close the file.
ww14:
	mov ah, 3Eh		; close file
	int 21h
	retn

		; Error opening file.  This is also called by the load command.
ww15:
	cmp ax, byte 2
	mov dx, doserr2		; File not found
	je ww16
	cmp ax, byte 3
	mov dx, doserr3		; Path not found
	je ww16
	cmp ax, byte 5
	mov dx, doserr5		; Access denied
	je ww16
	cmp ax, byte 8
	mov dx, doserr8		; Insufficient memory
	je ww16
	mov di, openerr1
	call hexword
	mov dx, openerr		; Error ____ opening file
ww16:
	jmp putsz


%ifn _EMS
xx: equ error
%else
		; X commands - manipulate EMS memory.
		;
		; Reference:
		;  http://www.nondot.org/sabre/os/files/MemManagement/LIMEMS41.txt

xx:	cmp al, '?'
	je short xhelp		; if a call for help
	or al, TOLOWER
	cmp al, 'a'
	je short xa		; if XA command
	cmp al, 'd'
	je short xd		; if XD command
	cmp al, 'm'
	je short xm		; if XM command
	cmp al, 'r'
	je short xr		; if XR command
	cmp al, 's'
	je xs			; if XS command
	jmp error

xhelp:	lodsb
	call chkeol
	mov dx, msg.xhelp
	jmp putsz		; print string and return

		; XA - Allocate EMS.
xa:	call emschk
	call skipcomma
	call getword		; get argument into DX
	call chkeol		; expect end of line here
	mov bx, dx

	mov ax, 5A00h		; use the EMS 4.0 version to alloc 0 pages
	test bx, bx
	jz short .nullcnt
	mov ah, 43h		; allocate handle
.nullcnt:
	call emscall
	xchg ax, dx		; mov ax, dx
	mov di, xaans1
	call hexword
	mov dx, xaans
	jmp putsz		; print string and return

		; XD - Deallocate EMS handle.
xd:	call emschk
	call skipcomma
	call getword		; get argument into DX
	call chkeol		; expect end of line here

	mov ah, 45h		; deallocate handle
	call emscall
	xchg ax, dx		; mov ax,dx
	mov di, xdans1
	call hexword
	mov dx, xdans
	jmp putsz		; print string and return

		; XR - Reallocate EMS handle.
xr:	call emschk
	call skipcomma
	call getword		; get handle argument into DX
	mov bx, dx
	call skipcomma
	call getword		; get count argument into DX
	call chkeol		; expect end of line here
	xchg bx, dx

	mov ah, 51h		; reallocate handle
	call emscall
	mov dx, xrans
	jmp putsz		; print string and return

		; XM - Map EMS memory to physical page.
xm:	call emschk
	call skipcomma
	call getword		; get logical page
	mov bx, dx		; save it in BX
	call skipcomm0
	call getbyte		; get physical page (DL)
	push dx
	call skipcomm0
	call getword		; get handle into DX
	call chkeol		; expect end of line
	 pop ax			; recover physical page into AL
	 push ax
	mov ah, 44h		; function 5 - map memory
	call emscall
	mov di, xmans1
	xchg ax, bx		; mov al,bl
	call hexbyte
	add di, xmans2-xmans1-2
	pop ax
	call hexbyte
	mov dx, xmans
	jmp putsz		; print string and return

		; XS - Print EMS status.
xs:
	call emschk
	lodsb
	call chkeol		; no arguments allowed

		; First print out the handles and handle sizes.  This can be done either
		; by trying all possible handles or getting a handle table.
		; The latter is preferable, if it fits in memory.
	mov ah, 4Bh		; function 12 - get handle count
	call emscall
	cmp bx, (line_out_end-line_out)/4
	jbe short xs3			; if we can do it by getting the table
	xor dx, dx		; handle

xs1:
	mov ah, 4Ch		; function 13 - get handle pages
	call emscall.witherrors
	jnz short .err
	xchg ax, bx		; mov ax,bx
	call hndlshow
.cont:
	inc dl			; end of loop
	jnz short xs1		; if more to be done
	jmp short xs5		; done with this part

.err:
	cmp ah, 83h		; no such handle?
	je short .cont		; just skip -->
	jmp short emscall.errorhandle	; if other error -->

		; Get the information in tabular form.
xs3:
	mov ah, 4Dh		; function 14 - get all handle pages
	mov di, line_out
	call emscall
	test bx, bx
	jz short xs5
	mov si, di
xs4:
	lodsw
	xchg ax, dx
	lodsw
	call hndlshow
	dec bx
	jnz short xs4		; if more to go

xs5:
	mov dx, crlf
	call putsz		; print string

		; Next print the mappable physical address array.
		; The size of the array shouldn't be a problem.
	mov ax, 5800h		; function 25 - get mappable phys. address array
	mov di, line_out	; address to put array
	call emscall
	mov dx, xsnopgs
	jcxz xs7		; NO mappable pages!

	mov si, di
xs6:
	push cx
	lodsw
	mov di, xsstr2b
	call hexword
	lodsw
	mov di, xsstr2a
	call hexbyte
	mov dx, xsstr2
	call putsz		; print string
	pop cx			; end of loop
	test cl, 1
	jz short xs_nonl
	mov dx, crlf		; blank line
	call putsz		; print string
xs_nonl:
	loop xs6
	mov dx, crlf		; blank line
xs7:
	call putsz		; print string

		; Finally, print the cumulative totals.
	mov ah, 42h		; function 3 - get unallocated page count
	call emscall
	mov ax, dx		; total pages available
	sub ax, bx		; number of pages allocated
	mov bx, xsstrpg
	call sumshow		; print the line
	mov ah, 4Bh		; function 12 - get handle count
	call emscall
	xchg ax, bx		; ax = number of handles allocated
	mov dx, 0FFh		; total number of handles
	mov bx, xsstrhd
	jmp sumshow		; print the line

		; Call EMS
emscall:
	call .witherrors
	jz short .ret		; return if OK
.errorhandle:
	mov al, ah
	cmp al, 8Bh
	jg short .ce2		; if out of range (signed comparison intended)
	cbw
	mov bx, ax
	shl bx, 1
	mov dx, word [emserrs+100h+bx]
	test dx, dx
	jnz short .ce4		; if there's a word there
.ce2:
	mov dx, emserrx
	call putsz
	mov di, line_out
	call hexbyte
	call putsline_crlf
	jmp cmd3		; quit

.witherrors:
%if _PM
	call ispm
	jnz short .rm
[cpu 286]
	push word [ss:pspdbg]
	push 67h
	call intcall
	db __TEST_IMM16		; (skip int opcode)
__CPU__
.rm:
%endif
	int 67h
	test ah, ah
.ret:
emschk.ret:
	retn

		; Check for EMS

emschk:
%if _PM
	call ispm
	jnz short .rm
	mov bl, 67h
	mov ax, 0200h
	int 31h
	mov ax, cx
	mov bx, dx
	jmp short .check
.rm:
%endif
	push es
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jz short .int21_35
	xor ax, ax
	mov es, ax
		; maybe should disable this?
	les bx, [es:67h*4]
	jmp short .gotint
.int21_35:
%endif
	mov ax, 3567h		; get interrupt vector 67h
	int 21h
.gotint:
	mov ax, es
	pop es
.check:
	inc bx
	jz short .failed	; was 0FFFFh -->
	test ax, ax
	jz short .failed	; was 0000h -->
	mov ah, 46h
	call emscall.witherrors	; get version
	jz short .ret		; success -->
.failed:
	mov dx, emsnot
emscall.ce4:
	jmp prnquit		; otherwise abort with message -->

		; HNDLSHOW - Print XS line giving the handle and pages allocated.
		;
		; Entry	DX	Handle
		;	AX	Number of pages
		;
		; Exit	Line printed
		;
		; Uses	ax,cl,di.
hndlshow:
	mov di, xsstr1b
	call hexword
	mov ax, dx
	mov di, xsstr1a
	call hexword
	push dx
	mov dx, xsstr1
	call putsz		; print string
	pop dx
	retn

		; SUMSHOW - Print summary line for XS command.
		;
		; Entry	AX	Number of xxxx's that have been used
		;	DX	Total number of xxxx's
		;	BX	Name of xxxx
		;
		; Exit	String printed
		;
		; Uses	AX, CX, DX, DI
sumshow:
	mov di, xsstr3
	push di
	call trimhex
	xchg ax, dx		; mov ax,dx
	mov di, xsstr3a
	call trimhex
	pop dx			; mov dx,xsstr3
	call putsz		; print string
	mov dx, bx
	call putsz		; print string
	mov dx, xsstr4
	jmp putsz		; print string and return

		; TRIMHEX - Print word without leading zeroes.
		;
		; Entry	AX	Number to print
		;	DI	Where to print it
		;
		; Uses	AX, CX, DI.
trimhex:
	call hexword
	sub di, 4		; back up DI to start of word
	mov cx, 3
	mov al, '0'
.loop:
	scasb
	jne .done		; return if not a '0'
	mov byte [di-1], ' '
	loop .loop
.done:
	retn
%endif	; _EMS

		; Error handlers.
error:
	push ss
	pop es
	push ss
	pop ds
	mov cx, si
	sub cx, line_in+3
	add cx, word [promptlen]; number of spaces to skip
	cmp cx, 128
	jbe .valid
	xor cx, cx		; if we're really messed up
.valid:
	jmp near [throwret]
		; INP:	cx = number of spaces to indent

		; This is the default address in throwret.
		; Display the error, then jump to errret.
errhandler:
.:
	sub cx, byte 80
	jnc .
	add cx, byte 80
	jz err2
	mov al, 32
.loop:
	call putc
	loop .loop
err2:
	mov dx, errcarat
	call putsz		; print string
	jmp near [errret]	; return to the prompt (cmd3, aa01)


		; Terminate the attached process, if any
		;
		; OUT:	NZ if now no process attached
		;	ZR if still a process attached,
		;	 ie we failed to terminate this one
terminate_attached_process:
	testopt [internalflags], attachedterm
	jnz @F

	mov word [reg_cs], cs
	mov word [reg_eip], terminate
	 push ax		; (dummy to take space for return address)
	mov word [reg_ss], ss
	mov word [reg_esp], sp	; save current ss:sp
	 pop ax			; (discard)
%if _PM
	xor ax, ax
	mov word [reg_eip+2], ax
	mov word [reg_esp+2], ax
%endif
	call run

	testopt [internalflags], attachedterm
@@:
	retn


;--- this is called by "run"
;--- better don't use INTs inside
;--- set debuggee's INT 23/24

		; Low-level functions to reset to debuggee's interrupt vectors 23h/24h
		; INP:	-
		; OUT:	-
		; CHG:	bx, (e)dx, cx, ax
		; STT:	ds = our segment
		;	Do not use Int21, even if not in InDOS mode
setint2324:
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jnz .ret		; don't touch int23/24 -->
%endif
%if _PM
	call ispm
	jz .pm
%endif
	push es
	push di
	push si

	xor di, di
	mov es, ax
	mov di, 23h *4
	mov si, run2324
	movsw
	movsw
	movsw
	movsw

%if _PM
	call hook2F
%endif
	pop si
	pop di
	pop es
.ret:
	retn
%if _PM
.pm:
	push si
	mov si, run2324
	mov bx, 0223h
.loop:
	_386_o32		; mov edx, dword [si+0]
	mov dx, word [si+0]
	mov cx, word [si+4]
	mov ax, 0205h
	int 31h
	add si, 6
	inc bl
	dec bh
	jnz .loop
	pop si
	retn
%endif

		; Low-level functions to save debuggee's interrupt vectors 23h/24h
		;  and set our interrupt vectors instead
		; INP:	-
		; OUT:	-
		; CHG:	-
		; STT:	ds = our segment
		;	Do not use Int21, even if not in InDOS mode
getint2324:
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jnz .ret		; don't touch int23/24 -->
%endif
%if _PM
	call ispm
	jz .pm
%endif
	push si
	push di
	push es

	push ds
	pop es
	xor di, di
	mov ds, di
	mov di, run2324
	mov si, 23h *4
	push si
	movsw			; save interrupt vector 23h
	movsw
	movsw			; save interrupt vector 24h
	movsw
	pop di
	push es
	pop ds
	xor si, si
	mov es, si
	mov si, CCIV
	movsw
	movsw
	movsw
	movsw

	pop es
	pop di
	pop si
.ret:
	retn
%if _PM
cpu 286
.pm:
	_386_o32
	pusha
	mov di, run2324
	mov bx, 0223h
.loop:
	mov ax, 0204h
	int 31h
	_386_o32		; mov dword [di+0], edx
	mov word [di+0], dx
	mov word [di+4], cx
	add di, byte 6
	inc bl
	dec bh
	jnz .loop
%if _ONLYNON386
	db __TEST_IMM8		; (skip pusha)
%else
	db __TEST_IMM16		; (skip pushad)
%endif

restoredbgi2324:
setdbgi2324:
	_386_o32
	pusha
	mov si, dbg2324
	mov bx, 0223h
_386	xor edx, edx
.loop:
	lodsw
	mov dx, ax
	mov cx, cs
	mov ax, 0205h
	int 31h
	inc bl
	dec bh
	jnz .loop
	_386_o32
	popa
	retn
cpu 8086
%endif

%if 0
The next three subroutines concern the handling of Int23 and 24.
These interrupt vectors are saved and restored when running the
child process, but are not active when DEBUG itself is running.
It is still useful for the programmer to be able to check where Int23
and 24 point, so these values are copied into the interrupt table
during parts of the C, D, (DX, DI,) E, M, and S commands, so that
they appear to be in effect. The E command also copies these values
back.

Between calls to dohack and unhack, there should be no calls to DOS,
so that there is no possibility of these vectors being used when
DEBUG itself is running.

; As long as no DOS is loaded anyway, Int23 and Int24 won't be touched
by us, so the whole hack is unnecessary and will be skipped.
%endif

		; PREPHACK - Set up for interrupt vector substitution.
		; Entry	es = cs
prephack:
	cmp byte [hakstat], 0
	jne .err		; if hack status error -->
	push di
	mov di, sav2324		; debugger's Int2324
	call prehak1
	pop di
	retn

.err:
	push dx
	mov dx, ph_msg
	call putsz		; display error
	pop dx
	retn

		; INP:	di-> saved interrupt vectors
		; OUT:	-
		; CHG:	-
prehak1:
%if _PM
	call ispm
	jz .pm			; nothing to do
%endif
	push ds
	push si
	xor si, si
	mov ds, si
	mov si, 23h *4
	movsw
	movsw
	movsw
	movsw
	pop si
	pop ds
.pm:
	retn


		; DOHACK - Fake the interrupt vectors 23h and 24h to debuggee's
		; UNHACK - Restore interrupt vectors 23h and 24h to our values
		;	It's OK to do either of these twice in a row.
		;	In particular, the S command may do unhack twice in a row.
		; INP:	ds = our segment
		; OUT:	es = our segment
		; CHG:	-
		; STT:	Do not use Int21
dohack:
	push ss
	pop es
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jnz unhack.ret		; nothing to hack -->
%endif
	push si
	mov byte [hakstat], 1
	mov si, run2324		; debuggee's interrupt vectors
%if _PM
	call ispm
	jnz unhack.common
cpu 286
	_386_o32
	pusha
	mov bx, 0223h
.pm_loop:
	_386_o32
	mov dx, word [si+0+0]
	mov cx, word [si+0+4]
	mov ax, 205h
	int 31h
	add si, byte 6
	inc bl
	dec bh
	jnz .pm_loop
	_386_o32
	popa
	pop si
	retn
cpu 8086
%else
	jmp short unhack.common
%endif

unhack:
	push ss
	pop es
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jnz .ret		; nothing to hack -->
%endif
	mov byte [hakstat], 0
%if _PM
	call ispm
	jz restoredbgi2324
%endif
	push si
	mov si, sav2324		; debugger's interrupt vectors
.common:
	push di
	push es
	xor di, di
	mov es, di
	mov di, 23h *4
	movsw
	movsw
	movsw
	movsw
	pop es
	pop di
	pop si
.ret:
	retn


InDos:
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jnz .return		; always "in DOS" -->
%endif
	testopt [options], fakeindos
	jnz .return		; faking InDOS on anyway -->
	push ds
	push si
	lds si, [pInDOS]
	cmp byte [si], 0
	pop si
	pop ds
.return:
	retn


;	PARSECM - Parse command line for C and M commands.
;	Entry	AL		First nonwhite character of parameters
;		SI		Address of the character after that
;	Exit	DS:ESI		Address from first parameter
;		ES:EDI		Address from second parameter
;		ECX		Length of address range minus one
;		[bAddr32]	Set if any high word non-zero

parsecm:
	call prephack
	mov bx, word [reg_ds]	; get source range
	xor cx, cx
	call getrange		; get address range into bx:(e)dx bx:(e)cx
	push bx			; save segment first address
	call skipcomm0
	mov bx, word [reg_ds]
	_386_PM_o32	; sub ecx, edx
	sub cx, dx		; number of bytes minus one
	_386_PM_o32	; push edx
	push dx
	_386_PM_o32	; push ecx
	push cx
%if _PM
	mov cl, byte [bAddr32]
	push cx
	call getaddr		; get destination address into bx:edx
	pop cx
	or byte [bAddr32], cl	; if either is 32-bit, handle both as 32-bit
%else
	call getaddr		; get destination address into bx:dx
%endif
	_386_PM_o32
	pop cx		; pop ecx
	_386_PM_o32	; mov edi, edx
	mov di, dx
	_386_PM_o32
	add dx, cx	; add edx, ecx
	jc short errorj7	; if it wrapped around
	call chkeol		; expect end of line
	mov es, bx
	_386_PM_o32	; pop esi
	pop si
	pop ds
	retn

errorj7:
	jmp error

;	PARSELW - Parse command line for L and W commands.
;
;	Entry	AL	First nonwhite character of parameters
;		SI	Address of the character after that
;
;	Exit	If there is at most one argument (program load/write), then the
;		zero flag is set, and registers are set as follows:
;		bx:(e)dx	Transfer address
;
;		If there are more arguments (absolute disk read/write), then the
;		zero flag is clear, and registers are set as follows:
;
;		DOS versions prior to 3.31:
;		AL	Drive number
;		CX	Number of sectors to read
;		DX	Beginning logical sector number
;		DS:BX	Transfer address
;
;		Later DOS versions:
;		AL	Drive number
;		BX	Offset of packet
;		CX	0FFFFh

packet:	dd 0		; sector number
	dw 0		; number of sectors to read
	dd 0		; transfer address Segm:OOOO
%if _PM
	dw 0		; transfer address might be Segm:OOOOOOOO!
%endif

parselw:
	mov bx, word [reg_cs]	; default segment
	mov dx, 100h		; default offset
	cmp al, 13
	je plw2			; if no arguments
	call getaddr		; get buffer address into bx:(e)dx
	call skipcomm0
	cmp al, 13
	je plw2			; if only one argument
	push bx			; save segment
	push dx			; save offset
	mov bx, 80h		; max number of sectors to read
	neg dx
	jz plw1			; if address is zero
	mov cl, 9
	shr dx, cl		; max number of sectors which can be read
	mov di, dx
plw1:
	call getbyte		; get drive number (DL)
	call skipcomm0
	push dx
	add dl, 'A'
	mov byte [driveno], dl
	call getdword		; get relative sector number
	call skipcomm0
	push bx			; save sector number high
	push dx			; save sector number low
	push si			; in case we find an error
	call getword		; get sector count
	dec dx
	cmp dx, di
	jae short errorj7	; if too many sectors
	inc dx
	mov cx, dx
	call chkeol		; expect end of line
	testopt [internalflags], oldpacket| newpacket| ntpacket
	jnz plw3		; if using a packet -->
	pop si			; in case of error
	pop dx			; get LoWord starting logical sector number
	pop bx			; get HiWord
	test bx, bx		; just a 16-bit sector number possible
	jnz short errorj7	; if too big
	pop ax			; drive number
	pop bx			; transfer buffer ofs
	pop ds			; transfer buffer seg
	test cx, cx		; NZ
plw2:
	retn

		; disk I/O packet for Int25/Int26, Int21.7305, VDD
plw3:
	pop bx			; discard si
	mov bx, packet
	pop word [bx+0]		; LoWord sector number
	pop word [bx+2]		; HiWord sector number
	mov word [bx+4], cx	; number of sectors
	pop ax			; drive number
	pop word [bx+6]		; transfer address ofs
	pop dx
	xor cx, cx
%if _PM
	call ispm
	jnz plw3_1
	cmp byte [dpmi32], 0
	jz plw3_1
cpu 386
	mov word [bx+10], dx	; save segment of transfer buffer
	movzx ebx, bx
	shr edx, 16		; get HiWord(offset)
	cmp byte [bAddr32], 1
	jz plw3_1
	xor dx, dx
cpu 8086
plw3_1:
%endif
	mov word [bx+8], dx	; transfer address seg
	dec cx			; NZ and make cx = -1
	retn

;	PARSE_PT - Parse 'p' or 't' command. Also resets pagedcommand flag.
;	Entry	AL	First character of command
;		SI	Address of next character
;	Exit	CX	Number of times to repeat
;	Uses	AH,BX,CX,DX.

parse_pt:
	clropt [internalflags], pagedcommand
	call parseql		; process =addr
	call skipcomm0		; skip any white space
	mov cx, 1		; default count
	cmp al, ';'
	je ppt1
	cmp al, 13
	je ppt1			; if no count given
	call getword
	call chkeol		; expect end of line here
	mov cx, dx
	jcxz errorj10		; must be at least 1
ppt1:
	call seteq		; make the = operand take effect
	retn

;	PARSEQL - Parse `=' operand for `g', 'p' and `t' commands.
;	Entry	AL	First character of command
;			SI	Address of next character
;	Exit	AL	First character beyond range
;			SI	Address of the character after that
;			eqflag	Nonzero if an `=' operand was present
;			eqladdr	Address, if one was given
;	Uses AH,BX,CX,DX.

parseql:
	mov byte [eqflag], 0	; mark '=' as absent
	cmp al, '='
	jne peq1		; if no '=' operand
	call skipwhite
	mov bx, word [reg_cs]	; default segment
	call getaddrX		; get the address into bx:(e)dx
%if _PM
	mov word [eqladdr+2], 0
	cmp byte [bAddr32], 0
	jz .nohighofs
	o32			; mov dword [eqladdr], edx
.nohighofs:
%endif
	mov word [eqladdr+0], dx
	mov word [eqladdr+4], bx
	inc byte [eqflag]
peq1:
	retn


		; SETEQ - Copy the = arguments to their place, if appropriate.
		; (This is not done immediately, because the command may have
		; a syntax error.)
		; Uses AX.
seteq:
	cmp byte [eqflag], 0
	je .return		; if no `=' operand
	mov ax, word [eqladdr+0]
	mov word [reg_eip], ax
%if _PM
	mov ax, word [eqladdr+2]
	mov word [reg_eip+2], ax
%endif
	mov ax, word [eqladdr+4]
	mov word [reg_cs], ax
	mov byte [eqflag], 0	; clear the flag
.return:
	retn


%include "expr.asm"


%include "lineio.asm"



%if _BOOTLDR
		; Determine the amount of actual memory
		;
		; This is important to call at the time we need the size,
		; not just save the size initially. Loading other pre-boot
		; installers or RPLs will change the size.
		;
		; INP:	-
		; OUT:	dx = segment behind usable memory (taking EBDAs & RPLs into account)
		; CHG:	ax, cx, di, si
bootgetmemorysize:
	xor ax, ax
	mov ds, ax
	int 12h					; get memory size in KiB
	mov cl, 6
	shl ax, cl				; *64, convert to paragraphs
	push ax
	lds si, [ 2Fh *4 ]			; get current Int2F
	inc si					; pointer valid (not 0FFFFh) ? (left increased!)
	jz .norpl				; no -->
	mov ax, ds
	test ax, ax				; segment valid (not zero) ?
	jz .norpl				; no -->
	times 2 inc si				; +3 with above inc
	mov di, .rpl
	mov cx, .rpl_size
	repe cmpsb				; "RPL" signature ?
	jne .norpl				; no -->
	pop dx
	mov ax, 4A06h
	int 2Fh					; adjust usable memory size for RPL
	db __TEST_IMM8				; (skip pop)
.norpl:
	pop dx
		; dx = segment behind last available memory
	push ss
	pop ds
	retn

.rpl:	db "RPL"
	endarea .rpl
%endif


;--- ensure a debuggee is loaded
;--- set SI:DI to CS:IP, preserve AX, BX, DX

ensuredebuggeeloaded:
	push ax
	testopt [internalflags], attachedterm
	jnz @F			; not loaded, create -->
	pop ax
	retn			; done

@@:
	push bx
	push dx

	call set_efl_to_fl	; initialize EFL
	mov di, regs
	mov cx, 15*2		; (8 standard + 6 seg + eip) * 2
	rep stosw		; initialize all regs
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jz .dos
	mov ax, 50h
	push ax
	mov di, reg_ds
	stosw
	scasw			; (skip dummy high word)
	stosw
	scasw
	stosw
	scasw
	stosw
	call adusetup
	call bootgetmemorysize
	sub dx, 50h
	cmp dx, 1000h
	jbe .bootbelow64kib	; if memory left <= 64 KiB
	xor dx, dx		; dx = 1000h (same thing, after shifting)
.bootbelow64kib:
	mov cl, 4
	shl dx, cl
	dec dx
	dec dx
	mov word [reg_esp], dx
	pop es
	xchg dx, di		; es:di = child stack pointer
	xor ax, ax
	stosw			; push 0 on client's stack

	cmp byte [bInit], 0
	jnz .bootnomemtouch
	inc byte [bInit]
	mov word [es:0], 019CDh	; place opcode for int 19h at cs:ip
.bootnomemtouch:
	mov word [pspdbe], es
	jmp .return

.dos:
%endif
	mov byte [reg_eip+1], 100h>>8
	mov ah, 48h		; get size of largest free block
	mov bx, -1
	int 21h
	cmp bx, 11h		; enough for PSP + one paragraph for code/stack ?
	jb .return		; no -->
	mov ah, 48h		; allocate it
	int 21h
	jc .return		; (memory taken between the calls)

	push bx
	mov di, reg_ds		; fill segment registers ds,es,ss,cs
	stosw
	scasw			; (skip dummy high word)
	stosw
	scasw
	stosw
	scasw
	stosw
	call adusetup
	mov bx, word [reg_cs]	; bx:dx = where to load program
	mov es, bx
	pop ax			; get size of memory block
	mov dx, ax
	add dx, bx
	mov word [es:ALASAP], dx
	cmp ax, 1000h
	jbe .below64kib		; if memory left <= 64 KiB
	xor ax, ax		; ax = 1000h (same thing, after shifting)
.below64kib:
	mov cl, 4
	shl ax, cl
	dec ax
	dec ax
	mov word [reg_esp], ax
	xchg ax, di		; es:di = child stack pointer
	xor ax, ax
	stosw			; push 0 on client's stack

		; Create a PSP
	mov ah, 55h		; create child PSP
	mov dx, es
	mov si, word [es:ALASAP]
	clc			; works around OS/2 bug
	int 21h
	call setpspdbg		; reset PSP to ours

		; Finish up. Set termination address.
	mov ax, 2522h		; set interrupt vector 22h
	mov dx, int22
	int 21h
	mov word [es:TPIV], dx
	mov word [es:TPIV+2], ds

	cmp byte [bInit], 0
	jnz .nomemtouch
	inc byte [bInit]
	mov byte [es:100h], 0C3h	; place opcode for retn at cs:ip
.nomemtouch:

	mov word [pspdbe], es
	mov ax, es
	dec ax
	mov es, ax
	inc ax
	mov word [es:8+0], "DE"
	mov word [es:8+2], "BU"
	mov word [es:8+4], "GG"
	mov word [es:8+6], "EE"	; set MCB name
	mov word [es:1], ax	; set MCB owner
.return:
	clropt [internalflags], attachedterm
	push ss
	pop es

	mov si, word [reg_cs]
	mov di, word [reg_eip]
	pop dx
	pop bx
	pop ax
	retn


set_efl_to_fl:
	xor ax, ax		; initialize ax = 0 and FL = ZR NC etc
_no386	push ax			; dummy high word
	_386_o32	; pushfd
	pushf
	pop word [reg_efl]	; set to FL
	pop word [reg_efl+2]	; set to high word of EFL, or zero
	retn


%if _PM
		; Hook Int2F if a DPMI host is found. However for Win9x and DosEmu
		; Int2F.1687 is not hooked because it doesn't work. Debugging in
		; protected mode may still work, but the initial switch must be
		; single-stepped.
		;
		; CHG:	ax, bx, cx, dx, di
		; STT:	V86/RM
hook2F:
	testopt [internalflags], hooked2F|(!_BOOTLDR-1&nodosloaded)
	jnz .return		; don't hook now -->
	mov ax, 1687h		; DPMI host installed?
	int 2Fh
	test ax, ax
	jnz .return
	mov word [dpmientry+0], di	; true host DPMI entry
	mov word [dpmientry+2], es
	mov word [dpmiwatch+0], di
	mov word [dpmiwatch+2], es
	testopt [internalflags], nohook2F
	jnz .return		; can't hook Int2F -->
	mov word [dpmiwatch+0], mydpmientry
	mov word [dpmiwatch+2], cs
	mov ax, 352Fh
	int 21h
	mov word [oldi2F+0], bx
	mov word [oldi2F+2], es
	mov dx, debug2F
	mov ax, 252Fh
	int 21h
	setopt [internalflags], hooked2F
%if _DISPHOOK
	mov ax, cs
	push ds
	pop es
	mov di, dpmihookcs
	call hexword
	mov dx, dpmihook
	call putsz
%endif
.return:
	push ds
	pop es
	retn
%endif

ldebug_size	equ $-section.lDEBUG.vstart
	section ASMTABLE1
asmtable1_size	equ $-section.ASMTABLE1.vstart
	section ASMTABLE2
asmtable2_size	equ $-section.ASMTABLE2.vstart

	section DATASTACK
%define SECTIONFIXUP -$$+100h+ldebug_size+asmtable1_size+asmtable2_size

		; I/O buffers
line_in:	resb 1			; maximal length of input line
		resb 1			; actual length (must be one less than previous byte)
		resb 255		; buffer for 13-terminated input line
.end:
%if _NUM_G_BP
g_bplist:
.used_count:	resb 1			; for the byte counter of saved breakpoints
.bp:		resb _NUM_G_BP*BPSIZE
.end:
%endif
trim_overflow:	resb 1			; actually part of line_out to avoid overflow of trimputs loop
line_out:	resb 263
		resb 1			; reserved for terminating zero
line_out_end:
	; alignb causes the section to be aligned. which we DON'T want
	; because our section size computations expect sections to be
	; consecutive without any alignment inbetween.
	; This means turning off sectalign isn't enough either: each
	; section might be completely unaligned. Therefore, we have to
	; replace align by code that takes our section fixup into account.
		;alignb 16
        resb (16 - (($+SECTIONFIXUP) % 16)) % 16
auxbuff:	resb _AUXBUFFSIZE	; aux buffer
		;alignb 16		; stack might be re-used as GDT, so align it on a paragraph
        resb (16 - (($+SECTIONFIXUP) % 16)) % 16
stack:		resb _STACKSIZE
		;alignb 2		; ensure stack aligned
        resb (2 - (($+SECTIONFIXUP) % 2)) % 2
stack_end:

datastack_size	equ $-section.DATASTACK.vstart

	section INIT
initstart:
		db 255,0,13		; initialized line_in of DATASTACK
					; All the other fields of DATASTACK are initialized
					; by the initialization code as necessary.

%include "init.asm"

init_size	equ $-section.INIT.vstart



imagepsp_size:	equ 100h+ldebug_size+asmtable1_size+asmtable2_size+init_size
	endarea imagepsp, 1			; size of PSP and image during installation

resimagepsp_size:	equ 100h+ldebug_size+asmtable1_size+asmtable2_size+datastack_size
	endarea resimagepsp, 1			; size of PSP and image when installed

%if imagepsp_size > (64*1024-228)
 %error Output .COM file is too large (initial stack might overflow)
%endif


	numdef _USE_FINAL__
%if __NASM_VERSION_ID__ < 020A0000h || __USE_FINAL__ == 0
%if __PASS__ != 1
 section DATASTACK
 %assign __CHECK_INITFIRST ..@init_first+SECTIONFIXUP
 %if __CHECK_ENDOFINITCONT >= __CHECK_INITFIRST
  %error end of initcont (%[__CHECK_ENDOFINITCONT]) >= \
		..@init_first (%[__CHECK_INITFIRST]), initcont overwrites itself
 %endif
 %assign __CHECK_RESIDENTSIZE resimagepsp_size
 %if __CHECK_TEMPSTACK > __CHECK_RESIDENTSIZE
  %error ..@tempstack (%[__CHECK_TEMPSTACK]) > \
		resident size (%[__CHECK_RESIDENTSIZE]), stack destroys MCB
 %endif
%endif
%endif
