
%if 0

lDebug line input and output

Copyright (C) 1995-2003 Paul Vojta
Copyright (C) 2008-2012 C. Masloch

Usage of the works is permitted provided that this
instrument is retained with the works, so that any entity
that uses the works is notified of this instrument.

DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.

%endif



iseol?:
	cmp al, 13
	je .ret
	cmp al, ';'
.ret:
	retn

		; Check for end of line
		;
		; INP:	al = first character
		;	ds:si-> next character
		; OUT:	ZR
		;	al = 13
		;	(does not return if anything on line beside blanks)
chkeol:
	call skipwh0
	call iseol?
	je iseol?.ret		; if EOL -->

errorj8:
	jmp error

;	SKIPCOMMA - Skip white space, then an optional comma, and more white
;		space.
;	SKIPCOMM0 - Same as above, but we already have the character in AL.
		; STK:	3 word
skipcomma:
	lodsb
skipcomm0:
	call skipwh0
	cmp al, ','
	jne .return		; if no comma
	push si
	call skipwhite
	cmp al, 13
	jne .noteol		; if not end of line
	pop si
	mov al, ','
	retn
.noteol:
	add sp, byte 2		; pop si into nowhere
.return:
	retn


		; Skip alphabetic characters, and then white space
		;
		; INP:	ds:si-> first character
		; OUT:	al = first non-blank character behind alphabetic characters
		;	ds:si-> character behind the first non-blank behind alpha.
skipalpha:
.:
	lodsb
	and al, TOUPPER
	sub al, 'A'
	cmp al, 'Z'-'A'
	jbe .
	dec si

		; Skip blanks and tabs
		;
		; INP:	ds:si-> first character
		; OUT:	al = first non-blank character
		;	ds:si-> character behind the first non-blank
		; CHG:	-
		; STK:	1 word
skipwhite:
	lodsb

		; Same as above, but first character in al
		;
		; INP:	al = first character
		;	ds:si-> next character
		; OUT:	al = first non-blank character
		;	ds:si-> character behind the first non-blank
		; CHG:	-
		; STK:	1 word
skipwh0:
	cmp al, 32
	je skipwhite
	cmp al, 9
	je skipwhite
	retn

		; Compare character with separators
		;
		; INP:	al = character
		; OUT:	ZR if al is blank, tab, comma, semicolon or equal sign
		;	NZ else
ifsep:
	cmp al, 32
	je .return
	cmp al, 9
	je .return
	cmp al, ','
	je .return
	cmp al, ';'
	je .return
	cmp al, '='
.return:
	retn

		; SHOWSTRING - Print ASCIZ string.
showstring.next:
	stosb
showstring:
	lodsb
	test al, al
	jnz .next
	retn


		; Dump byte as decimal number string
		;
		; INP:	al = byte
		;	di-> where to store
		; OUT:	-
		; CHG:	di-> behind variable-length string
decbyte:
	push ax
	push cx
	mov cx, 100
	call .div
	mov cl, 10
	call .div
	add al, '0'
	stosb
	pop cx
	pop ax
	retn

.div:
	xor ah, ah
	div cl
	or ch, al
	jz .leadingzero
	add al, '0'
	stosb
.leadingzero:
	xchg al, ah
	retn



		; dump high word of eax - assumes 386
hexword_high:
cpu 386
	rol eax, 16
	call hexword
	rol eax, 16
cpu 8086
	retn


		; hexdword - dump dword (in eax) to hex ASCII - assumes 386
		; HEXWORD - Print hex word (in AX).
		; HEXBYTE - Print hex byte (in AL).
		; HEXNYB - Print hex digit.
		; Uses	none.
%if 0	; currently disabled because only one call made to here (ID command)
hexdword:
	call hexword_high
%endif
hexword:
	xchg al, ah
	call hexbyte
	xchg al, ah

hexbyte:
	push cx
	mov cl, 4
	rol al, cl
	call hexnyb
	rol al, cl
	pop cx

hexnyb:
	push ax
	and al, 0Fh
	add al, 90h
	daa
	adc al, 40h
	daa			; these four instructions change to ASCII hex
	stosb
	pop ax
	retn

;	TAB_TO - Space fill until reaching the column indicated by AX.
;	(Print a new line if necessary.)

tab_to:
	push ax
	sub ax, di
	ja tabto1		; if there's room on this line
	call trimputs
	mov di, line_out
tabto1:
	pop cx
	sub cx, di
	mov al, 32
	rep stosb		; space fill to the right end
	retn

		; Trim excess blanks, append linebreak and display line_out.
		;
		; INP:	di-> behind last character to display, or blank
		;
		; Note:	May overflow if line_out only contains blanks. The byte at
		;	trim_overflow is used to avoid overflows.
trimputs:
	dec di
	cmp byte [di], 32
	je trimputs
	inc di

		; Append linebreak and display line_out
		;
		; INP:	di-> behind last character to display
putsline_crlf:
	mov ax, 10<<8| 13
	stosw

		; Display line_out
		;
		; INP:	di-> behind last character to display
putsline:
	mov cx, di
	mov dx, line_out
	sub cx, dx

		; Display message
		;
		; INP:	dx-> message to display
		;	cx = length of message
		; STT:	all segment registers same
		; CHG:	ax, bx, cx, dx
		;
		; Note:	For init, this must be 8086-compatible in 86 Mode.
puts:
			; The following code contains most of the paging support.
			; Based on the number of LF characters in the string it
			; displays only parts of the string, then interrupts it by
			; the "[more]" prompt which waits for any key before
			; proceeding. This is ensured to work proper in InDOS mode.
			;
			; Paging is deactivated if the command's output mustn't be
			; paged (clears pagedcommand, which is set by cmd3). It is
			; also not used when we output to a file.
	testopt [options], nonpagingdevice
	jnz .display			; deactivated by user -->
	call InDos			; InDOS mode ?
	jnz .dontcheckredirection	; yes, then we display with Int10 anyway -->
	testopt [internalflags], outputfile
	jnz .display			; output redirected to file. never page -->
	testopt [options], nondospaging
	jnz .dontcheckredirection
	testopt [internalflags], inputfile
	jnz .display			; input redirected from a file. never page -->
.dontcheckredirection:
	push di
	push cx				; used as variable: remaining (not yet displayed) line length
	mov di, dx			; es:di-> string, cx = length
.looplf:
	jcxz .display_pop		; end of string (or ended in LF) -->
				; Important: We only ever jump back to .looplf when cx
				; zero means it's okay to ignore the waiting prompt as
				; flagged below. This is (A) at the start of a string,
				; where cx is the whole string's length, (B) after
				; determining that prompting is not yet necessary, in
				; which case the flag was checked earlier already, (C)
				; after the flag has been set and a substring was already
				; displayed (so cx is again the whole substring's length)
				; or (D) just after the prompt was displayed, in which
				; case the flag cannot be set.
				; In case A and C, when the (sub)string is empty (ie. cx
				; is zero) it's crucial to ignore the waiting prompt as
				; this is the exact behaviour we want: If nothing is
				; displayed anymore before the getline code prompts
				; anyway, do not display our prompt.
	testopt [internalflags], promptwaiting	; do we have a prompt to display ?
	jnz .promptnow			; yes, display it before the string -->

	push es
	mov ax, 40h			; 0040h is a bimodal segment/selector
	mov es, ax
	mov al, byte [ es:84h ]		; rows on screen
	pop es
	cmp byte [ linecounter ], al
	jb .notyet			; not yet reached -->
	testopt [internalflags], pagedcommand	; active ?
	jnz .prompt			; yes, prompt -->
	dec byte [ linecounter ]	; keep count, but don't prompt til next LF
	jmp short .notyet

.prompt:
	 pop ax				; ax = length of string, cx = length of string remaining
	sub ax, cx			; ax = length of string til LF
	xchg ax, cx			; cx = til LF incl., ax = behind LF
	 push ax			; new count
				; cx = length til LF
				; ds:dx-> start of part til LF
	call .display			; display part of message which fits on screen
	 pop cx
	 push cx			; update cx from variable
	mov dx, di			; dx-> start of next part
	setopt [internalflags], promptwaiting	; mark as prompting necessary
	jmp short .looplf		; now check whether anything follows at all
				; This is the magic to suppress unnecessary prompts as
				; were displayed previously. Now, we'll set this flag
				; which effectively displays the prompt before (!) any
				; other output is done. Previously, the prompt would be
				; displayed right here. The only case where behaviour
				; changed is when no more output occurs until the flag
				; is reset elsewhere - ie. if getline prompts anyway.

.promptnow:
	push dx
	push cx
	mov byte [ linecounter ], 0	; prompting, so reset the line counter
	clropt [internalflags], promptwaiting
	mov dx, msg.more
	mov cx, msg.more_size
	call .display			; print string (avoiding a recursion)

				; This option is a hack for the sole use of
				; demo scripts that only want the user to press
				; a key for paging.
	testopt [options], nondospaging
	jz .getc
	call getc.rawnext		; get a character from BIOS
	jmp short .dispover
.getc:
	call getc			; get a character
.dispover:
	cmp al, 3			; is it Ctrl+C ?
	je .ctrlc			; yes, handle that -->
	mov dx, msg.more_over
	mov cx, msg.more_over_size
	call .display			; overwrite the prompt (avoiding a recursion)
	pop cx
	pop dx

.notyet:
	mov al, 10
	repne scasb			; search LF
	jne .display_pop		; none -->

	inc byte [ linecounter ]	; record how many LFs will be displayed
	jmp short .looplf		; search for next LF -->

.display_pop:
	pop cx
	pop di
.display:
			; Non-paged output code follows.
	call InDos
	jnz .notdos
	mov bx, 1			; standard output
	mov ah, 40h			; write to file
	doscall
	retn

.ctrlc:
	mov dx, msg.ctrlc
	mov cx, msg.ctrlc_size
	call .display			; visually acknowledge Ctrl+C and start a new line
	jmp cmd3			; abort currently running command -->
		; If handled by DOS, Ctrl+C causes our process to be terminated.
		; Because we are self-owned, we re-enter our code at debug22 then.
		; debug22 only does some re-initialization of registers before
		; entering cmd3. Therefore, instead of aborting we can directly jump
		; to cmd3 here. This has the additional benefit of not requiring DOS
		; at all, so that no workarounds for InDOS mode and boot loader
		; operation are necessary.

		; No command should fail spectacularly when being aborted this way,
		; because in fact every command calling puts can already be aborted by
		; DOS's Ctrl+C checking if DOS is used. This check is really only an
		; _additional_ way the commands can be aborted.

		; Note that a more complete way to support command abortion would be
		; to hook Int1B, and to keep a flag of whether Ctrl+C or Ctrl+Break
		; were requested, and to additionally check before or after every I/O
		; operation whether Ctrl+C was pressed using non-destructive reads.
		; In short, exactly what DOS does.

.notdos:
	push si
	testopt [internalflags], usecharcounter
	jnz .dontresetcharcounter
	mov byte [ charcounter ], 1
				; This assumes we always start at the beginning of a line.
				; Therefore any call to puts must display at the beginning
				; of a line or tab parsing will not work. Only calls to puts
				; not containing tab characters may display partial lines.
				; (Calls to puts with partial lines and tab characters have
				; to set the flag usecharcounter in internalflags.)
.dontresetcharcounter:
	jcxz .return
	mov si, dx
.loop:
	lodsb
	cmp al, 9
	jne .nottab			; is no tab -->
	mov al, byte [ charcounter ]
	and al, 7			; at 8 character boundary ?
	mov al, 32			; (always replaced by blank)
	jz .nottab			; yes, don't use hack -->
	inc cx
	dec si				; find tab again next lodsb
.nottab:
	cmp al, 13
	jne .notcr
	mov byte [ charcounter ], 0	; increased to one before displaying
.notcr:
%if 0				; currently we never receive BS here
	cmp al, 8
	jne .notbs
	mov ah, 0Fh
	int 10h				; get page
	mov bl, al			; save number of characters per column
	push cx
	mov ah, 03h
	int 10h				; get cursor position dx
	pop cx
	dec byte [ charcounter ]	; assume not at start of line
	mov al, 8			; changed by Int10
	or dl, dl
	jnz .dontcount			; not first column, so display normal -->
	mov byte [ charcounter ], 1	; assume at start of screen
	or dh, dh
	jz .next			; at start of screen, don't display -->
	dec dh				; previous line
	mov dl, bl
	mov byte [ charcounter ], dl	; really at end of line (one-based counter)
	dec dl				; last column
	mov ah, 02h
	int 10h				; set new cursor position
	jmp short .next
.notbs:
%endif
	cmp al, 10
	je .dontcount			; must not count line feeds!
	inc byte [ charcounter ]
.dontcount:
	mov bx, 0007
	mov ah, 0Eh
	int 10h
.next:
	loop .loop
.return:
	pop si
	retn

		; Display ASCIZ message
		;
		; INP:	dx-> ASCIZ message to display
		; CHG:	-
		; STT:	ds = es = ss
		;
		; Note:	For init, this must be 8086-compatible in 86 Mode.
putsz:
	push ax
	push bx
	push cx
	push dx
	push di
	mov di, dx			; es:di-> string
	xor al, al
	mov cx, -1
	repne scasb			; search zero
	neg cx
	dec cx
	dec cx				; cx = length of message
	pop di
	call puts
	pop dx
	pop cx
	pop bx
	pop ax
	retn

		; Display character
		;
		; INP:	al = character to display
		; CHG:	-
		; STT:	ds = es = ss
putc:
	push bx
	push cx
	push dx
	push ax
	mov cx, 1			; one character
	mov dx, sp			; ds:dx-> ax on stack
	call puts
	pop ax
	pop dx
	pop cx
	pop bx
	retn


		; Get character/key
		;
		; OUT:	al = character (if zero, look for ah)
		;	ah = scan code or zero
		; CHG:	ax
		;
		; Idles system when in InDOS mode. When not in InDOS mode, Int21.08
		; is used which is assumed to idle the system itself.
		;
		; Note:	For init, this must be 8086-compatible in 86 Mode.
getc:
	call InDos
	jz .dos
.rawnext:
	testopt [options], biosidles	; idling disabled?
	jnz .rawkey		; yes, just request a key -->
	mov ah, 01h
	int 16h			; key available ?
	jnz .rawkey		; yes -->
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jnz .hlt		; can't call 2F -->
%endif
	mov ax, 1680h
	int 2Fh			; release timeslice in multitasker
	test al, al
	jz .rawnext		; check again -->
%if _PM
	call ispm
	jnz .hlt

	push bx
	push cx
	push es
	_386_PM_o32	; push edi
	push di
_386	xor edi, edi		; clear EDIH
	xor cx, cx		; (copy no words from stack)

[cpu 286]
	mov di, sp
	sub di, 50		; di-> where sp will point
	push word [pspdbg]	; ss
	push di			; sp
	sub sp, byte 12		; cs:ip (ignored), segments (uninitialized)
	pushf
	push cx			; EAXH (uninitialized)
	push 1680h		; AX
	sub sp, byte 12		; ecx, edx, ebx (uninitialized)
	push cx
	push cx			; reserved (zero)
	sub sp, byte 12		; ebp, esi, edi (uninitialized)

	push ss
	pop es			; es:(e)di-> RM call structure
	mov ax, 0300h
	mov bx, 2Fh		; bl = interrupt, bh = reserved (zero)
	int 31h			; call real mode 2F.1680
__CPU__

	add sp, byte 28		; discard RM call structure
	pop ax			; get AX
	add sp, byte 20		; discard RM call structure

	_386_PM_o32	; pop edi
	pop di
	pop es
	pop cx
	pop bx

	test al, al
	jz .rawnext		; check again -->
%endif
.hlt:
	testopt [options], nohlt
	jnz .rawnext
%if _PM
 %if (protectedmode|dpminohlt)&~0FF00h
  %error Option bits re-ordered, adjust code here
 %endif
	mov al, byte [internalflags+1]
	and al, (protectedmode|dpminohlt)>>8
	xor al, (protectedmode|dpminohlt)>>8
	jz .rawnext		; DPMI host throws GPF when we execute hlt -->
%endif
	sti
	hlt			; else idle by hlt
	jmp short .rawnext	; check again -->
.rawkey:
	xor ax, ax
	int 16h			; get the key and scancode
	retn

.dos:			; DOS character devices handle one-byte characters. Therefore
			; non-ASCII keys cannot be returned with scancode in the high
			; byte of the same call. A non-ASCII key will be split into
			; two characters by CON: one NUL byte followed by the scancode.
	mov ah, 8
	int 21h			; wait for a key
	mov ah, 0		; assume it is ASCII
	or al, al
	jne .return		; ASCII, return with ah zero -->
	mov ah, 8
	int 21h			; scancode of non-ASCII key to al
	xchg al, ah		; to ah
	mov al, 0		; return zero for non-ASCII key
.return:
	retn



;	GETLINE - Print a prompt (address in DX, length in CX) and read a line
;	of input.
;	GETLINE0 - Same as above, but use the output line (so far), plus two
;	spaces and a colon, as a prompt.
;	GETLINE00 - Same as above, but use the output line (so far) as a prompt.
;	Entry	CX	Length of prompt (getline only)
;		DX	Address of prompt string (getline only)
;
;		DI	Address + 1 of last character in prompt (getline0 and
;			getline00 only)
;
;	Exit	AL	First nonwhite character in input line
;		SI	Address of the next character after that
;	Uses	AH,BX,CX,DX,DI

getline0:
	mov ax, 32<<8|32	; add two spaces and a colon
	stosw
	mov al, ':'
	stosb
getline00:
	mov dx, line_out
	mov cx, di
	sub cx, dx

getline:	; note: this entry is no longer used
	mov word [promptlen], cx	; save length of prompt
	mov byte [linecounter], 0	; reset counter
	clropt [internalflags], promptwaiting

	call InDos
	jnz getline_nofile	; InDOS, not reading from a file -->
	cmp byte [notatty], 0	; check this weird flag
	je getline_nofile	; not reading from a file -->

numdef NEWFULLHANDLING, 1

		; This part reads the input line from a file (in the case of
		; `debug < file').  It is necessary to do this by hand because DOS
		; function 0Ah does not handle EOF correctly otherwise.  This is
		; especially important for DEBUG because it traps Control-C.
	mov word [lastcmd], dmycmd	; disable auto-repeat while reading from a file

%if _NEWFULLHANDLING
	mov di, line_in+3	; read max
%else
	mov di, line_in+2
%endif
	mov si, word [bufnext]
	cmp si, word [bufend]
	jb .char_buffered	; if there's a character already
	call fillbuf
	jc qq			; if EOF, quit -->
.char_buffered:
%if _NEWFULLHANDLING
	dec di
%endif

		; Discard an LF if the last character read was CR.
	cmp byte [notatty], 13	; last parsed character was CR ?
	jne .no_lf_skip		; no, nothing more to do -->
	cmp byte [si], 10	; first read character is LF ?
	jne .no_lf_skip		; no -->
	inc si			; skip the LF
	inc byte [notatty]	; avoid repeating this
.no_lf_skip:
	call puts		; display prompt (having checked it wasn't EOF)

		; si-> next character in buffer
		; w[bufend]-> behind last valid character of buffer
gl1:
	mov cx, word [bufend]
	sub cx, si		; cx = number of valid characters in buffer
	jz gl3			; if none -->
gl2:
	lodsb
	cmp al, 13
	je gl4
	cmp al, 10
	je gl4			; if EOL -->
	stosb
	loop gl2		; if more valid characters -->

		; The buffer is empty. Fill it again.
gl3:
%if _NEWFULLHANDLING
	inc di
%endif
	call fillbuf
%if _NEWFULLHANDLING
	dec di
%endif
	jnc gl1			; if we have more characters -->
	mov al, 10
%ifn _NEWFULLHANDLING	; should now always have at least one byte free
	cmp di, line_in+LINE_IN_LEN
	jb gl4
	dec si
	dec di
%endif
gl4:
	mov word [bufnext], si
	mov byte [notatty], al	; store 10 or 13 (depending on the kind of EOL)
	mov al, 13
	stosb			; terminate line for our usage
	mov cx, di
	mov dx, line_in + 2
	sub cx, dx
	call puts		; print out the received line
	dec cx
	mov byte [line_in+1], cl
	jmp short getline_eol	; done

getline_nofile:
d3	push dx
d3	call .skipstr
d3	asciz 8,32,32,8,36
d3 .skipstr:
d3	pop dx
%if _DEBUG
	d3bp
%endif
d3	mov ah, 09h
d3	int 21h
d3	call putsz
d3	pop dx
d3	push dx
d3	push cx
d3	call puts
d3	pop cx
d3	pop dx
	call puts		; display prompt
	mov dx, line_in
	call InDos
	jnz rawinput
	mov ah, 0Ah		; buffered keyboard input
	doscall
getline_eol:
	mov al, 13
	call putc		; fix ZDOS Int21.0A display bug
	mov al, 10
	call putc
	mov si, line_in+2
	jmp skipwhite

rawinput:
	push di
	push ds
	pop es
	mov di, line_in+2
.next:
	call getc.rawnext
	test al, al			; waste?
	je .next
	cmp al, 0E0h
	je .next			; waste -->
	cmp al, 08h
	je .del
	cmp al, 7Fh
	je .del				; backspace -->
	cmp al, 13
	je .done
	cmp di, line_in+LINE_IN_LEN-1	; buffer filled?
	jb .store			; no, store -->
	mov al, 7
	db __TEST_IMM8			; skip to .put; beep!
.store:
	stosb				; store character
.put:
	call putc
	jmp short .next

.done:
	stosb				; store the CR (there always is room)
	xchg ax, di			; -> behind CR
	sub al, ((-section.DATASTACK.vstart+100h+ldebug_size \
				+asmtable1_size+asmtable2_size) \
		 +line_in+3) & 0FFh	; length of string, excluding CR
		; (This instruction disregards the unnecessary higher byte.)
	pop di				; restore di
	mov byte [line_in+1], al	; store the length byte
	jmp short getline_eol

.del:
	cmp di, line_in+2
	jz .next
	dec di
	call fullbsout
	jmp short .next

fullbsout:
	mov al, 8
	call putc
	mov al, 32
	call putc
	mov al, 8
	jmp putc

		; Fill input buffer from file.
		;
		; INP:	di-> first available byte in input buffer
		; OUT:	CY if DOS returned an error or EOF occured
		;	NC if no error
		;	si = di
		; CHG:	-
fillbuf:
	push ax
	push bx
	push cx
	push dx
	mov si, di		; we know this already
	mov ah, 3Fh		; read from file
	xor bx, bx
	mov cx, line_in+LINE_IN_LEN
	mov dx, di
	sub cx, di
	jbe .ret_cy		; if no more room -->
	doscall
	jc .ret_cy		; if error -->
	test ax, ax
	jz .ret_cy		; if EOF -->
	add dx, ax		; -> behind last valid byte
	db __TEST_IMM8		; (NC)
.ret_cy:
	stc
	mov word [bufend], dx	; -> behind last valid byte
	pop dx
	pop cx
	pop bx
	pop ax
	retn
