
%if 0

lDebug code and commands (P, T, G) to run debuggee code

Copyright (C) 1995-2003 Paul Vojta
Copyright (C) 2008-2012 C. Masloch

Usage of the works is permitted provided that this
instrument is retained with the works, so that any entity
that uses the works is notified of this instrument.

DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.

%endif



		; G command - go.
gg:
	xchg ax, bx		; mov bx, ax
	mov ax, word [reg_cs]	; save original CS
	mov word [eqladdr+4], ax
	xchg ax, bx		; mov ax, bx
	call parseql		; process =addr

%ifn _NUM_G_BP
	call chkeol
%else
		; Store the address of each breakpoint into the buffer. We also
		; make sure that there aren't too much breakpoints. (The user can
		; specify them with 2 byte per breakpoints which gives about 128
		; breakpoints with a full command line.) The breakpoints will only
		; be set later when we have verified that the line contains no
		; syntax errors and that there aren't too many breakpoints.
	mov di, g_bplist.used_count
	xor ax, ax
	stosb			; counter of saved breakpoints
gg3:
	dec si			; don't use skipcomm0 instead - need to restore al
	call skipcomma
	cmp al, ';'
	je gg4
	cmp al, 13
	je gg4			; if done -->
	mov bx, word [eqladdr+4]; default segment
	call getaddr		; get address into bx:(e)dx
	cmp di, g_bplist.end-BPSIZE
	ja error		; can't store another breakpoint, g_bplist is full -->
	call getlinear		; dx:ax = linear address
	stosw
	xchg ax, dx		; to store high byte/word
%if _PM
	stosw
%else
	stosb			; bits 24-31 (dh) always zero in 21-bit addresses
%endif
	mov al, 0CCh
	stosb			; later filled with the byte read from this address
	inc byte [g_bplist.used_count]
	jmp short gg3

gg4:
	mov si, g_bplist.used_count
	xor ax, ax
	lodsb			; si-> first point
	mov cx, ax		; cx = number of saved breakpoints
	push cx
	call gg_writepoints	; Store breakpoint bytes in the given locations.
	jnc .points_set		; successful -->
	pop dx
		; dx = number of points tried to write
		; cx = number of points not written
	sub dx, cx		; = number of points written
	mov cx, dx
			; We now first have to try restoring all the points we
			; already set because they might be inside the DOS or
			; BIOS handlers we would otherwise call. So instead of
			; displaying errors as we detect them, all the intel is
			; stored first until all points have been taken care of
			; (if possible). We then display error messages.
	mov bp, sp		; -> behind error info
	add dx, dx
	sub sp, dx
	push ax			; store error info on point that failed to be written
	call gg_restorepoints
	pop ax
		; ax = info on initially failed point
		; cx = 0-based index of initially failed point
		;    = number of points tried to restore
	pushf
	mov si, cx
	add si, si
	add si, si		; *4
%if _PM
	add si, cx		; *5
%endif
	add si, g_bplist.bp
		; cx = 0-based index of initially failed point
		; ax = info
		; si-> point

	push ax
	push cx
	mov dx, msg.Gbp_the
	call putsz
	mov ax, cx
	inc ax
	call putordinalbyte	; (the number will be < 256 as _NUM_G_BP is <=128)
	mov dx, msg.Gbp_lin
	call putsz
	mov di, line_out
%if _PM
	mov ax, word [si+2]
	call hexword
%else
	mov al, byte [si+2]
	call hexbyte
%endif
	mov ax, word [si]
	call hexword
	call putsline
	pop cx
	pop ax
	mov dx, msg.Gbp_reach
	cmp al, 2
	je .reach
	mov dx, msg.Gbp_write
.reach:
	call putsz
	popf
	call gg_handlefailedrestore
	mov sp, bp
	retn

.points_set:
	pop cx			; = number of points set

 %if 0
	mov si, g_bplist.bp
	jcxz .no_point_on_ip
	mov bx, [reg_cs]	; bx = cs
	_386_PM_o32
	mov dx, [reg_eip]	; (e)dx = (e)ip
	call getlinear		; dx:ax = linear address of cs:eip
	mov bx, ax		; dx:bx
.check_point_on_ip:
	lodsw
	cmp ax, bx
%if _PM
	lodsw
	jne .check_next_point_on_ip
	cmp ax, dx
%else
	lodsb
	jne .check_next_point_on_ip
	cmp al, dl
%endif
	jne .check_next_point_on_ip

		; Good, there's this point. (It should be the only one here.)
		; First, restore it's instruction.
	lodsb
	call getsegmented
	jc $			; this should not happen
	call writemem
	jc $			; this should not usually happen

; interrupt ? emuint : .isstdtrace (including DPMI hack, pushf handling)

 %endif	; 0

%endif	; _NUM_G_BP

	call run		; Now run the program.

%if _NUM_G_BP
	xor cx, cx
	mov cl, byte [g_bplist.used_count]
	mov bp, sp		; -> behind error info
	mov dx, cx
	add dx, dx
	sub sp, dx
	call gg_restorepoints	; try restoring points
	call gg_handlefailedrestore	; handle any failure
	mov sp, bp		; remove the stack frame

		; Finish up. Check if it was one of _our_ breakpoints.
	cmp word [run_int], int3msg
	jne gg9			; if not interrupt 03h -->

	mov di, g_bplist.bp
	xor cx, cx
	xchg byte [di-1], cl	; number of saved breakpoints
	jcxz gg9		; none, so always unexpected -->

			; Get previous cs:eip (where breakpoint was executed if any at all).
	mov bx, [reg_cs]	; bx = cs
	_386_PM_o32
	mov dx, [reg_eip]	; (e)dx = (e)ip
	_386_PM_o32
	dec dx			; bx:(e)dx = previous (e)ip
			; (getlinear doesn't use the high word of edx if it's a 16-bit cs)
	call getlinear		; dx:ax = linear address of this cs:eip

gg6:
	scasw			; ax matches ?
	jne .axdif		; no -->
	xchg ax, dx
%if _PM
	scasw			; dx matches ?
%else
	scasb			; dl matches ?
%endif
	xchg ax, dx
	jne .dxdif		; no -->
				; it's one of our breakpoints, adjust (e)ip
%if _PM
	call testattrhigh
	jz .16			; 16-bit cs -->
	o32			; dec dword [reg_eip]
.16:
%endif
	dec word [reg_eip]	; re-execute (restored) opcode one byte in front of this
	jmp dumpregs

.axdif:
%if _PM
	scasw			; skip dx value
%else
	inc di			; skip dl value
%endif
.dxdif:
	inc di			; skip saved (actually CCh) byte
	loop gg6		; try next if there's any
gg9:
%endif	; _NUM_G_BP
	jmp unexpectedinterrupt	; print messages for unexpected breakpoint and quit.


%if _NUM_G_BP
		; Restore breakpoints. On errors remember failures but restore all remaining anyway.
		;
		; INP:	cx = number of breakpoints to restore (<= 255),
		;		assumed at beginning of g_bplist.bp
		;	bp-> behind cx words for error info
		; OUT:	NC if all points restored successfully
		;	CY if at least one point couldn't be restored,
		;	 error info filled:	reason (0 = no error,
		;					1 = couldn't write,
		;					2 = unreachable,
		;					3 = overwritten),
		;				new byte (if reason 3)
		; CHG:	ax, bx, (e)dx, si, di, es
gg_restorepoints:
	mov si, cx
	add si, si
	add si, si
%if BPSIZE == 5
	add si, cx
%endif
	add si, g_bplist.bp - BPSIZE	; -> last point in list (first to restore)

	push ss
	pop es
	mov di, bp		; es:di-> error info
	push cx
	dec di
	dec di
	xor ax, ax
	std
	rep stosw		; initialize error info
	cld
	pop cx

	clc			; assume success
	push cx
	pushf
	jcxz .done		; nothing to do -->
.loop:
	call gg_writepoints_restore	; Restore breakpoint bytes.
	jnc .done		; successful -->
	pop dx			; discard flags
	pop bx
	push bx
	pushf			; store (CY) flags

	xchg al, ah
	push ax
	mov di, si
	sub di, BPSIZE+g_bplist.bp
%if BPSIZE == 5
	mov ax, di
	xor dx, dx
	mov di, 5
	div di
	mov di, ax		; di = 0-based point index
	shl di, 1		; di = 0-based error info offset
%elif BPSIZE == 4
	shr di, 1		; di = 0-based error info offset
%else
 %error "Unexpected BPSIZE"
%endif
	sub di, bx
	sub di, bx
	pop word [bp+di]	; store error info
	dec cx			; exclude the failed point
	sub si, 2*BPSIZE	; -> the point _before_ failed one
	jmp short .loop
.done:
%if _PM
	call getsegmented_resetmode
%endif
	popf			; get flags. CY if any couldn't be restored
	pop cx			; restore cx
.ret:
	retn


		; Loop through saved breakpoints and exchange the saved
		; byte with that one at the actual address. Used to write
		; the breakpoints.
		;
		; INP:	si-> current point
		;	cx = number of points to write (might be zero)
		; OUT:	NC if successful
		;	CY if error writing a point,
		;	 cx = number of points still to write (including failed one)
		;	 (si-BPSIZE)-> point that failed
		; CHG:	ax, bx, (e)dx, si, cx, di
gg_writepoints:
	mov di, 1
	db __TEST_IMM16		; (skip xor, NC)

		; Same, but go through the breakpoints in reverse order
		; and check that what we overwrite is a 0CCh byte. If so,
		; restore the original value. (The 0CCh is discarded.)
		;
		; Additionally:
		; OUT:	CY if error writing a point,
		;	 ah = 1 if error because point could not be written
		;	 ah = 2 if error because address is unreachable
		;	 ah = 3 if error because point contained non-0CCh value,
		;	  al = new byte
gg_writepoints_restore:
	xor di, di		; (NC)
gg_wp:
	jcxz .return		;if nothing to do --> (still NC from xor/test)
.loop:
	lodsw
	xchg ax, dx
%if _PM
	lodsw
%else
	xor ax, ax		; high byte zero
	lodsb
%endif
	xchg ax, dx		; dx:ax = linear address
	call getsegmented	; bx:(e)dx = segmented address
	lodsb			; get byte to write
	mov ah, 2
	jc .return		; not in PM anymore/address not available --> (CY)
	test di, di		; writing?
	jnz .forward_nocheck	; yes -->

.backward_check:
	push ax
	call readmem		; read current byte
	cmp al, 0CCh		; is this still what we wrote?
	mov ah, 3
	stc
	jne .return_discard	; nope --> (CY)
	pop ax
	call writemem		; return the byte to its original value
	jc .next		; failed --> (CY, handled there)
	lea si, [si-2*BPSIZE]	; adjust (for reverse writing)
	jmp short .next

.forward_nocheck:
	call writemem
	mov byte [si-1], al	; save the previous byte there
.next:
	mov ah, 1		; (in case of error)
	jc .return		; failed to write --> (CY)
	loop .loop
.return:			; (NC)
	retn

.return_discard:
	pop dx
	retn


putordinalbyte:
	mov di, line_out
	call decbyte
	mov dx, "st"
	dec ax
	jz .gotsuf		; if ax was one -->
	mov dx, "nd"
	dec ax
	jz .gotsuf		; if ax was two -->
	mov dl, 'r'
	dec ax
	jz .gotsuf		; if ax was three -->
	mov dx, "th"
.gotsuf:
	mov ax, dx
	stosw
	jmp putsline


		; INP:	bp-> error info
		;	cx = number of restored points
		;	CY if any points failed to be restored
gg_handlefailedrestore:
	jnc .failure_ret
.restorefailed:
	mov di, cx
	add di, cx
	neg di
	push ss
	pop es
	mov bx, 1
	mov si, g_bplist.bp
.restfailure_loop:
	mov ax, word [bp+di]
	test al, al		; failed?
	push di
	jnz .restfailure_display; yes -->
.restfailure_next:
	pop di
	inc bx			; increment counter
	add si, BPSIZE		; -> next point
	inc di
	inc di			; +bp-> next error info
	jnz .restfailure_loop	; not yet at end -->
.failure_ret:
	retn

		; si-> point
		; ax = info
		; bx = point's 1-based index
.restfailure_display:
	push ax
	push bx
	mov dx, msg.Gbp_the
	call putsz
	mov ax, bx
	call putordinalbyte	; (the number will be < 256 as _NUM_G_BP is <=128)
	mov dx, msg.Gbp_lin
	call putsz
	mov di, line_out
%if _PM
	mov ax, word [si+2]
	call hexword
%else
	mov al, byte [si+2]
	call hexbyte
%endif
	mov ax, word [si]
	call hexword
	call putsline
	mov dx, msg.Gbp_restore
	call putsz
	mov di, line_out
	mov al, byte [si+BPSIZE-1]
	call hexbyte
	call putsline
	pop bx
	pop ax
	mov dx, msg.Gbp_r_reach
	cmp al, 2
	je .restfailure_gotmsg
	mov dx, msg.Gbp_r_write
	cmp al, 1
	je .restfailure_gotmsg
	mov dx, msg.Gbp_r_overw1
	call putsz
	mov al, ah
	push bx
	mov di, line_out
	call hexbyte
	call putsline
	pop bx
	mov dx, msg.Gbp_r_overw2
.restfailure_gotmsg:
	call putsz
	jmp short .restfailure_next


%endif	; _NUM_G_BP

		; INP:	If currently in RM,
		;	 bx:dx = segment:offset of address
		;	If currently in PM,
		;	 bx:(e)dx = selector:offset of address
		; OUT:	CY if address is invalid,
		;	 because Int31.0006 failed for bx or
		;	 because 32-bit address overflowed or
		;	 because A20 could not be switched on
		;	NC if address is valid,
		;	 dx:ax = linear address
		;	 dh is always zero if the address is in RM address space
		; CHG:	(e)ax, (e)bx, (e)dx
getlinear:
%if _PM
	call ispm
	jnz .rm
	mov ax, 0006h
	push cx
	push dx
	int 31h			; get selector base address into cx:dx
	pop ax			; (edxh:)ax = offset, cx:dx = base
	jc .return_cx

	xor bx, bx		; assume 16-bit PM segment
_386	call testattrhigh
_386	jz .16
_386	push edx
_386	pop bx
_386	pop bx			; bx = high word edx (32-bit PM segment)
.16:				; bx:ax = offset
	add ax, dx
	adc bx, cx		; add the base
	xchg bx, dx		; dx:ax = 32-bit linear address

.return_cx:
	pop cx
	retn
.rm:
%endif
	mov ax, bx
	push cx
	mov cl, 4
	rol ax, cl
	pop cx
	mov bx, 0FFF0h
	and bx, ax		; bx = low word adjustment
	and ax, byte 0Fh	; ax = higher bits which don't fit in the low word
	add dx, bx
	adc ax, byte 0
	xchg ax, dx		; dx:ax = 21-bit linear address
	testopt [internalflags], debuggeeA20
	jnz .return		; A20 line enabled, no need to adjust (NC)
	and dl, ~10h		; clear corresponding bit of the address if it was set (NC)
.return:
	retn

%if _PM

; DEBUGX: when a mode switch from PM to RM did occur in the debuggee,
; breakpoint addresses in non-RM address space are unreachable.
; To enable the debugger to reset the breakpoints, it has to switch
; temporarily to PM. (In DEBUG/X 1.19, a switch from RM to PM in the
; debuggee will temporarily switch the debugger back to RM too. We
; handle this case without a switch as the linear RM address can be
; accessed directly in PM, assuming that the DPMI hosts linear-to-
; physical mapping for the RM address space is the same as the one
; we get in PM.)

; (To use mode switching in any case, the format the breakpoints are
; stored in needs to be modified. Additionally, the mode switching
; needs to be done elsewhere instead of in getsegmented. resetmode
; can be used as is, even if a mode switch from PM to RM occured.)

switchmode:
;--- raw switch:
;--- si:e/di: new cs:e/ip
;--- dx:e/bx: new ss:e/sp
;--- ax:      new ds
;--- cx:      new es
_386	xor ebx, ebx		; clear ebxh
	mov bx, sp
_386	xor edi, edi		; clear edih
	mov di, .back_after_switch
	call ispm
	jnz .pm
	mov ax, [dssel]		; switch rm -> pm
	mov si, [cssel]
	mov dx, ax
	mov cx, ax
	jmp far [dpmi_rm2pm]
.pm:
	mov ax, [pspdbg]	; switch pm -> rm
	mov si, ax
	mov dx, ax
	mov cx, ax
	_386_o32	; jmp far dword [dpmi_pm2rm]
	jmp far [dpmi_pm2rm]


		; INP:	al = direction, 0 = save state, 1 = restore state
		;	[auxbuff] = state buffer
		;	ES = debugger data selector
		; CHG:	edi
sr_state:
	testopt [internalflags], switchbuffer
	jz .return		; no need to call -->
_386	xor edi, edi		; clear edih
	mov di, auxbuff
	call ispm
	jnz .pm
	call far [dpmi_rmsav]
	retn
.pm:
	_386_o32	; call far dword [dpmi_pmsav]
	call far [dpmi_pmsav]
.return:
switchmode.back_after_switch:
getsegmented_resetmode.ret:
	retn


		; INP:	-
		; OUT:	-
		; CHG:	(e)ax, (e)bx, (e)cx, (e)dx, (e)si, (e)di, fs, gs
		; STT:	es = ds = ss = our segment/selector
		;
		; Switches back to RM if a mode switch to PM was done by getsegmented.
		; Does nothing otherwise. (Can be called multiple times.)
getsegmented_resetmode:
	testopt [internalflags], modeswitched	; switched mode previously ?
	je .ret			; no -->
	clropt [internalflags], modeswitched	; reset the flag
	call switchmode 	; switch back to the mode we were entered in (RM)
	mov al, 1
	jmp short sr_state	; restore state
%endif

		; INP:	dx:ax = linear address
		; OUT:	CY if inaccessible
		;	NC if accessible,
		;	 bx:(e)dx = segment:offset or selector:offset address
		;	 A temporary mode switch from RM to PM might have occured.
		;	 This has to be reset by calling getsegmented_resetmode.
		; CHG:	(e)ax, (e)bx, (e)dx, fs, gs
		; STT:	es = ds = ss = our segment/selector
		;
		; It is assumed that only one byte needs to be accessed.
		; (A workaround to access multiple bytes would be to access each
		;  byte separately and call this function for each of the bytes.)
		;
		; The TSR command code assumes that getsegmented.pm does not switch
		; modes and that it will return an offset in (e)dx that allows
		; 16-bit access. Adjust that code if either is no longer true.
getsegmented:
%if _PM
	call ispm
	jnz .rm
.pm:
	push cx
	mov bx, word [scratchsel]
	xchg ax, dx
	xchg ax, cx		; cx:dx = linear address
	mov ax, 0007h
	int 31h			; set base to the address
	pop cx
	jc .invalid
 %if 0	; scratchsel is expected by other code to access arbitrary data ??
	push cx
	mov ax, 0008h
	xor cx, cx
	xor dx, dx
	int 31h			; set limit to zero (access to one byte only)
	pop cx
	jc .invalid
 %endif
	_386_o32	; xor edx, edx
	xor dx, dx		; bx:(e)dx = selector:offset (using scratchsel with the address as base)
	retn			; (NC)
%endif
.rm:
	cmp dx, byte 10h	; check for address space
	jb .nothma		; below HMA, normal access -->
	je .checkhma		; possibly in HMA -->
.nonrmspace:			; above HMA
%if _PM
		; It's a PM address but we are in RM.
	testopt [internalflags], canswitchmode
	jz .invalid		; can't switch to PM -->
.switchmodes:
	_386_o32
	push si
	_386_o32
	push di
	_386_o32
	push cx
	setopt [internalflags], modeswitched	; set flag for resetmode
	mov al, 0
	call sr_state		; save state
	call switchmode 	; switch to PM
	_386_o32
	pop cx
	_386_o32
	pop di
	_386_o32
	pop si
	jmp short .pm

.invalid:			; the address is inaccessible
%endif
	stc
	retn

.checkhma:
	cmp ax, -10h		; valid offset for HMA ?
	jae .nonrmspace		; no, above HMA -->
	testopt [internalflags], debuggerA20	; A20 on, HMA accessible ?
	jz .nonrmspace		; no, treat as above HMA (DEBUGX) -->
	mov bx, 0FFFFh		; the HMA must always be addressed by segment FFFFh
	add ax, byte 10h	; and the offset is always at least 0010h (FFFFh:0010h = 00100000h)
		; (NC because we checked that this won't overflow)
	xchg ax, dx		; bx:dx = segment:offset
	retn

.nothma:
	push cx
	mov cl, 4
	ror dx, cl		; dx (high 4 bits) = high 4 bits of segment
	mov bx, ax
	shr bx, cl		; bx = low 12 bits of segment
	or dx, bx		; dx = segment
	and ax, byte 0Fh	; ax = low 4 bits of linear, used as offset (NC)
	xchg ax, dx
	xchg ax, bx		; bx:dx = segment:offset
	pop cx
_386_PM	movzx edx, dx
	retn


		; T command - Trace.
tt:
	mov ah, al
	and ah, TOUPPER
	cmp ah, 'M'
	jnz isnotmodeset
	call skipcomma
	cmp al, 13
	je ismodeget
	call getword
	call chkeol		; expect end of line here
	cmp dx, 1
	ja error
	je .set			; selected 1 -->
.clear:				; selected 0
	clropt [options], traceints
	jmp short .get
.set:
	setopt [options], traceints
.get:
ismodeget:
	mov al, '0'
	mov si, tmode0
	testopt [options], traceints
	jz .zero
	inc ax
	mov si, tmode1
.zero:
	mov byte [tmodev], al
	mov di, line_out
	push si
	mov si, tmodes
	call showstring
	pop si
	call showstring
	jmp putsline_crlf

isnotmodeset:
%if _TSR
	cmp ah, 'S'
	jne tt0
	mov ah, byte [si]
	and ah, TOUPPER
	cmp ah, 'R'
	je tsr
%endif
tt0:
	mov word [lastcmd], tt0
	call parse_pt		; process arguments

		; Do it <CX=count> times.
tt1:
	push cx
	call traceone		; call common code
	jc unexpectedinterrupt	; an unexpected interrupt occured -->
	call dumpregs		; dump registers
	pop cx
	loop tt1		; loop -->
	retn

%if _TSR
tsr:
	inc si
	lodsb
	call chkeol
	testopt [internalflags], tsrmode
	jz .try			; not yet resident -->
	mov dx, msg.alreadytsr
	jmp short .putsz
.try:
	mov dx, word [pspdbe]
	mov bx, word [pspdbg]
	mov di, 0Ah
.loop:
%if _PM
	mov cx, dx		; = original segment address
	call ispm
	jnz .rm
	push bx
	mov ax, dx
cpu 186
	shr dx, 12
	shl ax, 4		; shift to get a 32-bit linear address
cpu 8086
	call getsegmented.pm	; set up selector for access
		; This call makes some assumptions:
		; - No mode switch occurs; we are still in PM.
		;    Currently none is performed from PM.
		; - (e)dx isn't larger than about FFD0h.
		;    Currently scratchsel with an offset of zero is returned.
	mov di, dx		; -> PSP
	mov dx, bx
	pop bx
	add di, byte 0Ah	; -> PSP termination vector
.rm:
%endif
	mov es, dx
	mov ax, word [es:(di-0Ah)+16h]
	inc ax
	jz .pspnotfound
	dec ax
	jz .pspnotfound		; parent is invalid -->
%if _PM
	cmp ax, cx
%else
	cmp ax, dx
%endif
	je .pspnotfound		; parent is the process itself -->
	mov dx, ax
	cmp ax, bx
	jne .loop		; parent is not us -->
	cmp word [es:di], int22
	jne .psphooked
	cmp word [es:di+2], bx
	je .found		; correct vector --> (otherwise: hooked)
.psphooked:
	mov dx, msg.psphooked
	jmp short .putsz_es
.pspnotfound:
	mov dx, msg.pspnotfound
.putsz_es:
	push ss
	pop es
.putsz:
	jmp putsz

.found:
	mov si, psp22
	movsw
	movsw			; write our parent's vector
	add di, 16h-(0Ah+4)
	movsw			; write our parent
	setopt [internalflags], tsrmode	; note that we are resident
%if _PM
	push cx
%else
	push es
%endif
	mov dx, msg.nowtsr1
	call .putsz_es
	pop ax
	mov di, line_out
	call hexword
	call putsline
	mov di, psp22
	xor ax, ax
	stosw
	stosw
	stosw			; clear our parent/int22 fields
	mov dx, msg.nowtsr2
	jmp short .putsz
%endif


		; Print message about unexpected interrupt, dump registers, and
		; end command. This code is also used by the G and P commands.
unexpectedinterrupt:
	mov dx, word [run_int]
	call putsz		; print string
	cmp dx, progtrm
	je .noregs		; if it terminated, skip the registers
	call dumpregs
.noregs:
	jmp cmd3		; back to the start

		; Trace an instruction.
		; INP:	-
		; OUT:	NC if the breakpoint was hit,
		;	 d[reg_eip] adjusted
		;	CY if the breakpoint was not hit
traceone:
	xor cx, cx
	call getcseipbyte
	cmp al, 0CDh		; int opcode?
	jne .isstdtrace		; no -->
	inc cx
	call getcseipbyte
	cmp al, 3
	je .isstdtrace		; int 3 opcode -->
	testopt [options], traceints	; TM=1?
	jz isstdtraceX
	cmp al, 1
	je .isstdtrace		; int 1 opcode -->

		; TM==1, single-step into the INT
	mov bl, al
%if _PM
	call ispm
	jz .singlestep_into_interrupt_pm
%endif
	mov bh, 0
	push ds
	xor ax, ax
	mov ds, ax
	shl bx, 1
	shl bx, 1
	lds si, [bx+0]
	mov al, byte [si]
	cli
	inc byte [si]
	cmp byte [si], al
	mov byte [si], al
	sti
	mov bx, ds		; bx:si-> interrupt handler (RM, 16 bit)
	mov ax, bx
	pop ds
	jne .singlestep_into_interrupt_setbp

		; The interrupt handler is in a ROM.
%if 0
	jmp short isstdtraceX
%else
	xchg si, word [reg_eip]
	xchg ax, word [reg_cs]	; get cs:ip, set interrupt handler address
	mov cx, word [reg_efl]	; get flags
	push ds
	mov bx, word [reg_esp]
	mov ds, word [reg_ss]	; ds:bx-> debuggee stack
	sub bx, byte 6		; reserve enough space for flags, cs, ip
	inc si
	inc si			; skip CDh xxh opcode
	mov word [bx+4], cx
	mov word [bx+2], ax
	mov word [bx+0], si	; save flags, cs, ip on stack
	pop ds
	mov word [reg_esp], bx	; update sp
	and byte [reg_efl+1], ~(2|1)	; clear IF and TF (NC)
			; Note: If invalid flag values were previously set by the user
			; by directly accessing the FL or EFL register, these won't be
			; fixed by us now. This could be worked around by executing a
			; NOP in debuggee's environment (or only with debuggee's flags)
			; first, but I don't think it's much of an issue.
	retn

%endif
%if _PM
.singlestep_into_interrupt_pm:
	mov ax, 0204h
	int 31h
	mov bx, cx
	_386_o32	; mov esi, edx
	mov si, dx		; bx:(e)si-> interrupt handler
	test bl, 4		; is it a LDT selector? (NC)
	jz isstdtraceX		; no -->
%endif
.singlestep_into_interrupt_setbp:
	jmp proceedbreakpoint

.isstdtrace:
%if _PM
	call ispm
	jz .notdpmientry	; already in PM -->
	mov ax, w[reg_eip]	; is this a switch to protected mode ?
	cmp ax, w[dpmiwatch+0]
	jne .notdpmientry
	mov ax, w[reg_cs]
	cmp ax, w[dpmiwatch+2]
	je isdpmientry		; yes, catch it --> (this means really "go")
.notdpmientry:
%endif
	or byte [reg_efl+1], 1	; set single-step mode (cleared when returning into DEBUG)
	xor cx, cx
	call skipprefixes
	cmp al, 9Ch		; opcode "PUSHF"?
	jnz .notpushf
	call run

		; Clear TF in the fl word or efl dword
		; pointed to by debuggee's ss:(e)sp
	push es
%if _PM
	mov bx, word [reg_ss]	; get ss selector into bx
	mov es, bx
_386	call testattrhigh	; check whether a 32-bit ss
%else
	mov es, word [reg_ss]
%endif
	_386_PM_o32	; mov ebx, dword [reg_esp]
	mov bx, word [reg_esp]	; es:(e)bx-> debuggee's stack
_386_PM	jz .pushf_16
_386_PM	and byte [es:ebx+1], ~1	; clear TF
_386_PM	jmp short .pushf_common
.pushf_16:
	and byte [es:bx+1], ~1	; clear TF
.pushf_common:
	pop es
	jmp short .checkreturn
.notpushf:
	call run
.checkreturn:
	cmp word [run_int], int1msg
	je .ret			; if correct interrupt -->
	stc
.ret:
	retn

; an INT is to be processed (TM is 0)
; to avoid the nasty x86 bug which makes IRET
; cause a debug exception 1 instruction too late
; a breakpoint is set behind the INT

isstdtraceX:
	mov cx, 2
	call iswriteablecseip	; is it ROM ?
	jc traceone.isstdtrace	; is read-only -->
	mov bx, word [reg_cs]

		; (e)si = (e)ip + 2
		; We don't test whether it's a 32-bit code segment here.
		; The previous code would leave the high word of esi uninitialized then.
	_386_PM_o32	; mov esi, dword [reg_eip]
	mov si, word [reg_eip]
	_386_PM_o32	; add esi, byte 2
	add si, byte 2		; ! do not remove the byte override, else o32 won't work
	jmp proceedbreakpoint	; set BP at BX:(E)SI and run debuggee

		; Call getcseipbyte and loop while increasing cx if the returned
		; byte was a prefix. Returns the first non-prefix byte (an opcode)
		; in al. (WAIT or FWAIT is not considered a prefix because it's
		; really an opcode and we also trace it without executing a
		; following FPU opcode.)
skipprefixes:
.:
	call getcseipbyte
	cmp al, 26h
	je .prefix		; ES
	cmp al, 2Eh
	je .prefix		; CS
	cmp al, 36h
	je .prefix		; SS
	cmp al, 3Eh
	je .prefix		; DS
	cmp al, 0F0h
	je .prefix		; LOCK
	cmp al, 0F3h
	je .prefix		; REPZ
	cmp al, 0F2h
	je .prefix		; REPNZ
	_no386_jmps .noprefix	; no 386, following aren't prefixes (invalid opcodes on 186+) -->
	cmp al, 64h
	je .prefix		; FS
	cmp al, 65h
	je .prefix		; GS
	cmp al, 66h
	je .prefix		; o32/o16
	cmp al, 67h
	jne .noprefix		; not a32/a16
.prefix:
	inc cx
	; jmp short .
	jns .			; this is not correct but serves as hack to avoid an infinite loop
				; (note that getcseipbyte really uses cx as signed number)
	dec cx			; back to 07FFFh
.noprefix:
	retn


;--- test if memory at CS:E/IP can be written to
;--- return C if not

iswriteablecseip:
	call getcseipbyte	; get byte at CS:EIP+CX
	mov ah, al
	xor al, 0FFh
	call setcseipbyte
	jc .return
	call getcseipbyte
	cmp ah, al     		; is it ROM?
	stc
	jz .return
	mov al, ah
	call setcseipbyte
	clc
.return:
	retn


%if _PM
debuggerexception:
	call unhack
	mov dx, word [run_int]
	call putsz		; print string
%if _EXCCSIP
	mov dx, excloc
	call putsz
%endif
	jmp cmd3
%endif


%if _PM
[cpu 386]
		; INP:	dh = flags as for pp2,pp3,pp5 (1 = ASIZE, 2 = OSIZE)
		; OUT:	dh = flags as used by pp3,pp5 (1 = A32, 2 = O32)
pp_fix32bitflags:
	call testattrhigh
	jz .16
	xor dh, 1|2		; toggle OSIZE and ASIZE (once)
.16:
	retn
__CPU__
%endif

		; P command - proceed (i.e., skip over call/int/loop/string instruction).
pp:
	mov word [lastcmd], pp
	call parse_pt		; process arguments

		; Do it <CX=count> times.  First check the type of instruction.
pp1:
	push cx			; save cx
	mov dx, 15		; DL = number of bytes to go; DH = prefix flags.
	mov bx, word [reg_cs]
	_386_PM_o32	; mov esi, dword [reg_eip]
	mov si, word [reg_eip]
pp2:
	call pp16		; get next instruction byte into AL
	mov di, ppbytes
	mov cx, PPLEN
	repne scasb
	jne pp5			; if not one of these -->
	mov al,byte [di+PPLEN-1]; get corresponding byte in ppinfo
	test al, 80h		; prefix ?
	jz pp3			; no -->
	or dh, al		; set the OSIZE or ASIZE flags if either of these
			; Note:	Multiple OSIZE in a 16-bit cs do not toggle
			;	between decoding as O32 and O16, they're always
			;	decoded as O32. The same is true for A32, and
			;	in a 32-bit cs for O16 and A16.
	dec dl
	jnz pp2			; if not out of bytes -->
	mov dx, msg.warnprefix
	call putsz
	jmp short pp12

		; A repeatable string, interrupt, call immediate or loop
		; instruction is to be decoded. Finish the decoding and
		; skip the appropriate number of opcode bytes.
pp3:
_386_PM	call pp_fix32bitflags
	test al, 40h		; different opcode length depends on OSIZE ?
	jz .ignoreosize		; no -->
	and al, 3Fh
	and dh, 2
	add al, dh
.ignoreosize:
	cbw
_386_PM	movzx eax, ax		; clear high word (in case it counts)
	_386_PM_o32	; add esi, eax
	add si, ax
	jmp short pp11		; we have a skippable instruction here

pp5:
_386_PM	call pp_fix32bitflags
	cmp al, 0FFh		; FF/2 or FF/3 indirect call ?
	jne pp12		; no, just an ordinary instruction -->
	call pp16		; get MOD REG R/M byte
	and al, ~8		; clear lowest bit of REG field (/3 --> /2)
	xor al, 10h		; /2 --> /0
	test al, 38h
	jnz pp12		; if not FF/2 or FF/3 -->
	cmp al, 0C0h
	jae .adjust0		; if just a register -->
	test dh, 1
	jnz .a32		; if 32-bit addressing -->
	cmp al, 6
	je .adjust2		; if just plain disp16 -->
	cmp al, 40h
	jb .adjust0		; if indirect register -->
	cmp al, 80h
	jb .adjust1		; if disp8[reg(s)]
	jmp short .adjust2	; it's disp16[reg(s)]

		; Handle 32-bit addressing (A32 ModR/M referencing memory)
.a32:
	cmp al, 5
	je .adjust4		; if just plain disp32 -->
	xor al, 4
	test al, 7
	jnz .a32_nosib		; if no SIB byte -->
	_386_PM_o32	; inc esi
	inc si			; skip the SIB byte
.a32_nosib:
	cmp al, 40h
	jb .adjust0		; if indirect register -->
	cmp al, 80h
	jb .adjust1		; if disp8[reg(s)] -->
				; otherwise, it's disp32[reg(s)]
.adjust4:
	_386_PM_o32	; inc esi
	inc si			; skip an instruction byte
	_386_PM_o32	; inc esi
	inc si			; skip an instruction byte
.adjust2:
	_386_PM_o32	; inc esi
	inc si			; skip an instruction byte
.adjust1:
	_386_PM_o32	; inc esi
	inc si			; skip an instruction byte
.adjust0:
pp11:
_386_PM	call testattrhigh
_386_PM	jnz .32			; full 32-bit offset valid -->
_386_PM	movzx esi, si		; clear high word here
.32:
	call proceedbreakpoint	; run until the breakpoint is hit
	jc pp15			; unexpected -->
	jmp short pp13

pp12:
	or byte [reg_efl+1], 1	; set single-step mode
	call run		; trace instruction

		; We could check here for the correct address too, but that
		; would require disassembling the instruction and correctly so.
		; (Disassembling it incorrectly would only result in spurious
		; "Unexpected single-step interrupt" messages aborting multi-
		; traces though, so it won't be fatal.)
		; Wouldn't really be useful though: Only the "int1" or "int 01h"
		; instructions should cause this, and their operation means we
		; might as well behave as if the breakpoint was expected.
	cmp word [run_int], int1msg
	jne pp15		; if some other interrupt (unexpected) -->

pp13:
		; An expected breakpoint. Dump registers, then loop.
	call dumpregs
	pop cx
	loop pp14		; back for more -->
	retn

%if ($ - pp1 - 1) < 128
pp14: equ pp1
%else
pp14:	jmp pp1
%endif

pp15:
	jmp unexpectedinterrupt	; print message about unexpected interrupt
				; and quit

%if _PM
isdpmientry:
	testopt [internalflags], nohook2F
	jz .stdhook
	mov word [reg_eip], mydpmientry
	mov word [reg_cs], cs	; if Int2F not hooked, point to the hook here
.stdhook:
		; Run code until it returned far.
	mov bx, word [reg_esp]
	push ds
	mov ds, word [reg_ss]	; ds:bx-> (16-bit) stack
	mov si, word [bx+0]
	mov bx, word [bx+2]	; get (16-bit) far return address
	pop ds
%endif
		; Proceed over an instruction
		; INP:	bx:(e)si-> were to write the breakpoint
		; OUT:	NC if the breakpoint was hit,
		;	 d[reg_eip] adjusted
		;	CY if the breakpoint was not hit
proceedbreakpoint:
	_386_PM_o32		; mov edx, esi
	mov dx, si
	mov al, 0CCh
	call writemem
	jc sho .cantwrite

	push ax			; save old byte
	call getlinear
	push dx
	push ax			; save linear address of point
	call run
	pop ax
	pop dx			; restore address
	pop cx			; restore old byte
	push dx
	push ax			; save again for comparison

		; It's important to keep the linear address saved inbetween,
		; even though we save by value (as opposed to DEBUG/X G's saving
		; of the reference) because the selector that we used for the
		; access might now be invalid or (worse) point elsewhere, or
		; a mode change might have occured. (The latter is sometimes
		; handled by a specific kludge in DEBUG/X, but not always.)
	call getsegmented	; bx:(e)dx = segmented address
	jc $
	mov al, cl
	call writemem		; restore breakpoint byte
%if _PM
	call getsegmented_resetmode
%endif
	mov bx, word [reg_cs]
	_386_PM_o32
	mov dx, word [reg_eip]	; bx:(e)dx = cs:(e)ip
	call getlinear		; dx:ax = linear address of cs:(e)ip
	sub ax, byte 1
	sbb dx, byte 0		; dx:ax = linear address 1 before cs:(e)ip
	pop bx
	pop cx			; cx:bx = linear address of breakpoint (if any)
	cmp cx, dx
	jne .return_cy
	cmp ax, bx
	jne .return_cy		; is unexpected (not behind the breakpoint) -->

		; Need to check this here, because we have to
		; decrement (e)ip if the breakpoint was hit.
	cmp word [run_int], int3msg
	jne .return_cy		; is unexpected (not returned by interrupt 03h) -->
_386_PM	mov bx, word [reg_cs]
_386_PM	call testattrhigh
_386_PM	jz .16
_386_PM	o32		; dec dword [reg_eip]
.16:
	dec word [reg_eip]	; decrement (e)ip to point at the instruction
	clc
	retn

.return_cy:
	stc
	retn

.cantwrite:
	mov dx, cantwritebp
	jmp prnquit


		; PPX - Get next byte in instruction stream.
		; INP:	bx:(e)si-> next byte
		; OUT:	al = next byte
		;	(e)si incremented
pp16:
%if _PM
	call testattrhigh
%endif
	push ds
	mov ds, bx
%if _PM
	jz .16
	a32			; use esi for lodsb
.16:
%endif
	lodsb
	pop ds
	retn
		; begin loop over instruction bytes.


		; Run - Start up the running program.
		;
		; INP:	b[eqflag], a[eqladdr] = address given behind '=' for command
		;	w[pspdbe] = process of debuggee
		;	[run2324] = interrupt handlers 23h and 24h to set
		;	values for registers in d[reg_eax] etc
		; OUT:	(_DEBUG) [intsave] updated
		;	d[reg_eax] etc updated
		;	w[run_int]-> message of how execution returned
		;	UP, EI, high word efl = 0, es = ds = ss
		; CHG:	all
		; STT:	ds = ss
		;	UP
		;	(INP:es ignored)
run:
	call seteq			; set CS:IP to '=' address
	mov bx, word [pspdbe]
	call setpsp			; set debuggee's PSP
	call setint2324			; set debuggee's int 23/24
%if _DEBUG				; set this copy's divide/trace/breakpoint ints
 %if _TSR
..@patch_tsr_quit_run:
	db __TEST_IMM8
	db __REL8__(.skipints)
 %endif
	push cx
	push si
	push ax
	push dx
 %if _BOOTLDR
	push es
	push bx
 %endif
	mov cx, inttab_number
	mov si, inttab
.intloop:
	lodsb
	xchg ax, dx
	lodsw				; get address
	xchg ax, dx
 %if _BOOTLDR
	testopt [internalflags], nodosloaded
	jz .int21_25
	xor bx, bx
	mov es, bx
	mov bl, al
	add bx, bx
	add bx, bx
	mov word [ bx ], dx
	mov word [ bx+2 ], ds
	jmp short .intset
.int21_25:
 %endif
	mov ah, 25h			; set interrupt vector
	int 21h
.intset:
	loop .intloop
 %if _BOOTLDR
	pop bx
	pop es
 %endif
	pop dx
	pop ax
	pop si
	pop cx
.skipints:
%endif

	mov word [run_sp], sp		; save stack position
	sub sp, word [spadjust]
	mov word [SPSAV], sp
	cli
	mov sp, regs
%ifn _ONLY386
	_386_jmps .386			; -->
	pop ax
	pop ax				; discard all high words
	pop bx
	pop ax
	pop cx
	pop ax
	pop dx
	pop ax
	pop ax				; we'll get esp later
	pop ax
	pop bp
	pop ax
	pop si
	pop ax
	pop di
	pop ax
	pop es		  		; temporary load DS value into ES (to make sure it is valid)
	pop ax				; discard high words of segment registers
	pop es				; now load the true value for ES
%endif
%ifn _ONLYNON386
 %ifn _ONLY386
	jmp short .common
 %endif

.386:
cpu 386
	pop eax
	pop ebx
	pop ecx
	pop edx
	pop ax
	pop ax				; we'll get esp later
	pop ebp
	pop esi
	pop edi
	pop es		  		; temporary load DS value into ES (to make sure it is valid)
	pop ax				; discard high words of segment registers
	pop es				; now load the true value for ES
	; pop ax
	; pop ax			; get ss later
	; pop ax
	; pop ax			; get cs later
	; pop ax
	add sp, byte 5*2
	pop fs
	pop ax
	pop gs
cpu 8086
.common:
%endif
	mov ax, word [reg_eax]		; restore ax (used to discard words)
	mov ss, word [reg_ss]
%if _ONLYNON386
	mov sp, word [reg_esp]
%else
..@patch_no386_ds:
	o32			; mov esp, dword [reg_esp]
	mov sp, word [reg_esp]		; restore program stack
%endif
	mov byte [bInDbg], 0
	_386_o32		; push dword [reg_efl]
	push word [reg_efl]
	_386_o32		; push dword [reg_cs]	; high word is zero
	push word [reg_cs]
	_386_o32		; push dword [reg_eip]
	push word [reg_eip]
	test byte [reg_efl+1], 2	; IF set?
	mov ds, word [reg_ds]		; restore ds
	jz .di
	sti				; required for ring3 protected mode if IOPL==0
.di:
%if _ONLYNON386
	iret
%else
..@patch_no386_iret:
	o32			; iretd
	iret				; jump to program
%endif

; The byte at ..@patch_no386_ds will be adjusted to a ds prefix on non-386 processors.
; This does not change the following instruction's behaviour (aside from changing it
; to a 16-bit instruction as intended) and insures that sp is set in the instruction
; right behind the instruction that sets ss.

; The byte at ..@patch_no386_iret will be adjusted to an iret instruction on non-386 processors.
; This avoids the NOP that would be written there if _386_o32 was used, because the iret
; should follow right behind the sti instruction.


		; Interrupt 22h (program termination) handler.
int22:
	cli
	mov sp, cs
	mov ss, sp
	mov ds, sp
	mov word [run_int], progtrm	; set interrupt message
	mov word [lastcmd], dmycmd	; disable T/P/G auto-repeat
%if _PM
	mov sp, word [InDosSegm]
	mov word [pInDOS+2], sp
%if _USESDA
	mov sp, word [SDASegm]
	mov word [pSDA+2], sp		; return both values to RM addresses
%endif
	clropt [internalflags], protectedmode	; reset PM flag
%endif
	jmp intrtn1			; jump to register saving routine


		; Interrupt 00h (divide error) handler.
intr0:	mov word [cs:run_int], int0msg	; remember interrupt type
	jmp short intrtn		; jump to register saving routine


		; Interrupt 01h (single-step interrupt) handler.
intr1:	mov word [cs:run_int], int1msg	; remember interrupt type
	jmp short intrtn		; jump to register saving routine


		; Interrupt 03h (breakpoint interrupt) handler.
intr3:	mov word [cs:run_int], int3msg	; remember interrupt type
%if _CATCHINT06
	jmp short intrtn		; jump to register saving routine


		; Interrupt 06h (invalid opcode) handler.
intr6:	mov word [cs:run_int], int6msg	; remember interrupt type
%endif

		; Common interrupt routine.

		; Housekeeping.
intrtn:
	cli				; just in case
	pop word [cs:reg_eip]		; recover things from stack
	pop word [cs:reg_cs]
	pop word [cs:reg_efl]
	mov word [cs:reg_ss], ss	; save stack position
_386	and word [cs:reg_eip+2], byte 0	; we're from real mode
	_386_o32		; mov dword [cs:reg_esp], esp
	mov word [cs:reg_esp], sp
%if _PM
	clropt [cs:internalflags], protectedmode	; reset PM flag
	mov sp, cs
	mov ss, sp		; mov ss, cs	; (don't use the stack here)
intrtn2:				; <--- entry protected mode
	mov word [ss:reg_ds], ds	; ! word-aligned (AC flag)
	mov word [ss:reg_eax], ax	; ! word-aligned (AC flag)
	mov ax, ss
%else
	mov word [cs:reg_ds], ds	; ! word-aligned (AC flag)
	mov word [cs:reg_eax], ax	; ! word-aligned (AC flag)
	mov ax, cs
	mov ss, ax		; mov ss, cs
%endif
	mov ds, ax		; mov ds, ss
	mov ax, 2
%ifn _ONLY386
	_386_jmps .386			; -->
	mov sp, reg_es+2
	push es
	; sub sp, ax
	; sub sp, ax			; ds already saved
	; sub sp, ax			; don't overwrite high word of di
	sub sp, byte 3*2
	push di
	sub sp, ax
	push si
	sub sp, ax
	push bp
	; sub sp, ax
	; sub sp, ax			; sp already saved
	; sub sp, ax
	sub sp, byte 3*2
	push dx
	sub sp, ax
	push cx
	sub sp, ax
	push bx
%endif
%ifn _ONLYNON386
 %ifn _ONLY386
	jmp short .common
 %endif

.386:
cpu 386
	mov sp, reg_gs+2
	push gs
	sub sp, ax			; don't overwrite high words of segments
	push fs
	; sub sp, ax
	; sub sp, ax			; cs already saved
	; sub sp, ax
	; sub sp, ax			; ss already saved
	; sub sp, ax
	sub sp, byte 5*2
	push es
	; sub sp, ax
	; sub sp, ax			; ds already saved
	sub sp, byte 2*2
	push edi
	push esi
	push ebp
	; sub sp, ax
	; sub sp, ax			; sp already saved
	sub sp, byte 2*2
	push edx
	push ecx
	 pushfd				; (this overwrites reg_ebx)
	 add sp, ax			; discard low word of efl
	 pop word [reg_efl+2]
	 push 0
	 pushf				; (this also overwrites reg_ebx)
	 popfd				; clear high word of efl inside debugger (resets AC flag)
	push ebx
	mov ax, word [reg_eax]		; restore ax
	push eax			; so we don't overwrite it with 2 here
cpu 8086
.common:
%endif

		; Clean up.
intrtn1:
	mov sp, word [run_sp]		; restore running stack
	cld				; clear direction flag
	sti				; interrupts back on

	call getpsp
	mov word [pspdbe], bx

	call getint2324			; save debuggee's int 23/24, set debugger's int 23/24

	push ds
	pop es
	call setpspdbg			; set PSP of debugger
	clropt [reg_efl], 100h		; clear TF
%if _DEBUG				; reset to next copy's divide/trace/breakpoint ints
	push cx
	push si
	push di
	push ax
	push bx
	push dx
	mov cx, inttab_number
	mov di, intsave
	mov si, inttab
.intloop:
	lodsb
	mov bl, al
	add si, byte 2
	xchg si, di
	lodsw
	mov dx, ax
	lodsw
	xchg si, di
	push ds
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jz .int21_25_2
	push ax
	push dx
	xor ax, ax
	mov ds, ax
	xor bh, bh
	add bx, bx
	add bx, bx
	pop word [ bx ]
	pop word [ bx+2 ]
	jmp short .intset_2
.int21_25_2:
%endif
	mov ds, ax
	mov al, bl
	mov ah, 25h
%if _PM
 %fatal Cannot build DDEBUGX: handler switching needs to be fixed
%endif
	int 21h
.intset_2:
	pop ds
	loop .intloop
	pop dx
	pop bx
	pop ax
	pop di
	pop si
	pop cx
%endif

	setopt [internalflags], debuggerA20|debuggeeA20	; assume A20 is on
%if _PM
	call ispm
	jz .a20done			; assume A20 on. (is this the right thing to do?)
%endif
	push es
	push ds
	push di
	push si
	push cx
	xor si, si
	mov ds, si			; ds = 0000h
	dec si
	mov es, si			; es = FFFFh
	inc si				; ds:si = 0000h:0000h =  00000h
	mov di, 0010h			; es:di = FFFFh:0010h = 100000h (same address if it overflows)
	mov cx, di			; 32 byte (16 = 10h word)
	repe cmpsw			; compare them and assume A20 line switched off if same
	pop cx
	pop si
	pop di
	pop ds
	pop es
	jne .a20done			; not equal, A20 line is switched on -->
					; if equal, the A20 line is probably switched off
	clropt [internalflags], debuggerA20|debuggeeA20	; assume A20 is off

%if 0 ;_LOCALENABLEA20
	; This doesn't serve any particular reason if we have no business accessing the HMA.
	; What's more important is that the dump, assemble, and disassemble commands *should*
	; use a disabled A20 if it is disabled to the debuggee. Thus, enabling A20 belongs, if
	; at all, into getsegmented (similar to the switch to PM) as there may be breakpoints in
	; the HMA that we need to reset.
	mov ax, 4300h
	int 2Fh				; XMS v2 installation check
	cmp al, 80h			; installed ?
	jne .a20done			; no -->
	mov ax, 4310h
	int 2Fh				; get entry
	mov ah, 05h
	push cs
	call callfaresbx		; local enable A20
	push ds
	pop es
	dec ax
	jnz .a20done			; not able to enable A20 -->
		; actually check here to insure it is on?
	setopt [internalflags], debuggerA20	; our A20 is on
%endif
.a20done:

	mov byte [bInDbg], 1
	cmp word [run_int], progtrm
	jnz .isnotterm
	setopt [internalflags], attachedterm
%if _BOOTLDR
	mov ax, -1
	testopt [internalflags], nodosloaded
	jnz .no_int21_4D
%endif
	mov ah, 4Dh
	int 21h
.no_int21_4D:
	mov di, progexit
	call hexword
.isnotterm:
	retn

%if 0 ;_LOCALENABLEA20
callfaresbx:
	push es
	push bx
	retf
%endif
